-- Create table
create table YPREPOS01
(
  dummy                  VARCHAR2(1),
  rn                     NUMBER(17),
  authid                 VARCHAR2(30),
  ident                  NUMBER(17) default 0,
  company                NUMBER(17),
  jur_pers               NUMBER(17),
  date_from              DATE,
  date_to                DATE,
  acctype                NUMBER(17),
  account                NUMBER(17),
  analytic1              NUMBER(17),
  analytic2              NUMBER(17),
  analytic3              NUMBER(17),
  analytic4              NUMBER(17),
  analytic5              NUMBER(17),
  balunit                NUMBER(17),
  nomenclature           NUMBER(17),
  agent                  NUMBER(17),
  acnt_remn_quant        NUMBER(17,3) default 0,
  acnt_remn_sum          NUMBER(17,2) default 0,
  acnt_debit_turn_quant  NUMBER(17,3) default 0,
  acnt_debit_turn_sum    NUMBER(17,2) default 0,
  acnt_credit_turn_quant NUMBER(17,3) default 0,
  acnt_credit_turn_sum   NUMBER(17,2) default 0,
  acnt_res_quant         NUMBER(17,3) default 0,
  acnt_res_sum           NUMBER(17,2) default 0,
  amortperiod            NUMBER(17,2) default 0,
  amortall               NUMBER(17,2) default 0,
  rnspec                 NUMBER(17),
  inum                   VARCHAR2(20),
  model                  VARCHAR2(2000),
  datein                 DATE,
  nempty                 NUMBER(1) default 0
)
tablespace PARUS_MAIN
  pctfree 10
  initrans 1
  maxtrans 255
  storage
  (
    initial 64K
    next 1M
    minextents 1
    maxextents unlimited
  );
-- Create/Recreate indexes 
create index C_YPREPOS01 on YPREPOS01 (AGENT, ANALYTIC1, RN, ACCOUNT)
  tablespace PARUS_MAIN
  pctfree 10
  initrans 2
  maxtrans 255
  storage
  (
    initial 64K
    next 1M
    minextents 1
    maxextents unlimited
  );

grant select, insert, update,delete on YPREPOS01 to public;

-- Create table
create table YPREPOS02
(
  dummy       VARCHAR2(1),
  authid      VARCHAR2(30),
  acctype     NUMBER(17),
  account     NUMBER(17),
  analytic1   NUMBER(17),
  agent       NUMBER(17),
  qmat        NUMBER(17,3) default 0,
  smat        NUMBER(17,2) default 0,
  qos         NUMBER(17,3) default 0,
  sos         NUMBER(17,2) default 0,
  nomenclator NUMBER(17),
  jurpers     NUMBER(17),
  note        VARCHAR2(200),
  analytic2   NUMBER(17),
  analytic3   NUMBER(17),
  analytic4   NUMBER(17)
)
tablespace PARUS_MAIN
  pctfree 10
  initrans 1
  maxtrans 255
  storage
  (
    initial 64K
    next 1M
    minextents 1
    maxextents unlimited
  );
-- Grant/Revoke object privileges 
grant select, insert, update, delete on YPREPOS02 to PUBLIC;

create or replace function f_ypgetlinenumb(invGR in varchar2, invNUMB in varchar2)
  return varchar2
  as
    sSTR1 varchar2(10);
    sSTR2 varchar2(10);
    sRETURN varchar2(20);
    nINTNUMB1 number(2);
    nINTNUMB2 number(2);
    nINTNUMB3 number(2);
    nINTNUMB4 number(2);
    sBETWEEN  varchar2(2);
    sPADLNUMB varchar2(2);
    nPADLNUMB number(2);

  begin
/*      */

  nINTNUMB1 := 5;   --       
  nINTNUMB2 := 0;   --        ( 0 -  )

  nINTNUMB3 := 0;  --       
  nINTNUMB4 := 0;  --       ( 0 -  )

  sBETWEEN  := ''; --       
  sPADLNUMB := '0'; --       
  --nPADLNUMB := 6;  --      
  nPADLNUMB := 4;   -- egor -13577   06.06.2012 15:45


        if nvl(nINTNUMB1,0) = 0  then
           sSTR1 := inVGR;
        elsif nvl(nINTNUMB2,0) = 0 then
              sSTR1 := substr(invGR,nINTNUMB1);
        else
           sSTR1 := substr(invGR,nINTNUMB1, nINTNUMB2);
        end if;

        if nvl(nINTNUMB3,0) = 0  then
           sSTR2 := invNUMB;
        elsif nvl(nINTNUMB4,0) = 0 then
              sSTR2 := substr(invNUMB,nINTNUMB3);
        else
           sSTR2 := substr(invNUMB,nINTNUMB3, nINTNUMB4);
        end if;

        if nvl(nPADLNUMB,0) > 0  then
           sSTR2 := lpad(trim(sSTR2),nPADLNUMB,sPADLNUMB);
        end if;

        if sBETWEEN is null then
           sRETURN := trim(sSTR1)||trim(sSTR2);
        else
           sRETURN := trim(sSTR1)||sBETWEEN||trim(sSTR2);
        end if;


        return sRETURN;


  end;

/
grant execute on f_ypgetlinenumb to public;
  
CREATE OR REPLACE PROCEDURE P_YPTURNIKCREATE( nIDENT  in number,
                                              nSELECT in number,
                                              nPRINTSELECT in number,
                                              d1           in date default null,
                                              d2           in date default null,
                                              nAMORTBGN    in number default 0
                                              )
as
  nDEL     number(17);
  nINSERT  number(17);
  nAM1     number;
  nAM2     number;
  nZNAK    number;


  nPRNSPIS number(17);

  sINVNUMB varchar2(20);

  check1   number;
  check2   number;
  check3   number;


  nRNOPER  number;

  sum_insh1 number(15,2);
  rn_recsp  number(17);
  nTMP_SUMI number(15,2);
  nTMP_SUMA number(15,2);


  ngr_anl1  number;
  ngr_anl2  number;
  ngr_anl3  number;
  ngr_anl4  number;

  nANL_SEL1 number := 0;
  nANL_SEL2 number := 0;
  nANL_SEL3 number := 0;
  nANL_SEL4 number := 0;

begin

  /*PKG_SESSION_VARS.GET('VALTURNS.GROUP_ANL1',ngr_anl1);
  PKG_SESSION_VARS.GET('VALTURNS.GROUP_ANL2',ngr_anl2);
  PKG_SESSION_VARS.GET('VALTURNS.GROUP_ANL3',ngr_anl3);
  PKG_SESSION_VARS.GET('VALTURNS.GROUP_ANL4',ngr_anl4);*/ ---92745
  begin
    select t.group_analytic1, t.group_analytic2, t.group_analytic3, t.group_analytic4
    into ngr_anl1, ngr_anl2, ngr_anl3, ngr_anl4
    from valturns_param t
    where t.ident = nident
      and t.authid = user;
    exception
    when OTHERS then
      ngr_anl1 := PKG_SESSION_VARS.GET_NUM('VALTURNS.GROUP_ANL1');
      ngr_anl2 := PKG_SESSION_VARS.GET_NUM('VALTURNS.GROUP_ANL2');
      ngr_anl3 := PKG_SESSION_VARS.GET_NUM('VALTURNS.GROUP_ANL3');
      ngr_anl4 := PKG_SESSION_VARS.GET_NUM('VALTURNS.GROUP_ANL4');
  end; ---92745


  if ngr_anl1 = 1 or ngr_anl2 = 1 or ngr_anl3 = 1 or ngr_anl4 = 1  then
     nANL_SEL1 := 1;
  end if;
  if ngr_anl1 = 2 or ngr_anl2 = 2 or ngr_anl3 = 2 or ngr_anl4 = 2  then
     nANL_SEL2 := 1;
  end if;
  if ngr_anl1 = 3 or ngr_anl2 = 3 or ngr_anl3 = 3 or ngr_anl4 = 3  then
     nANL_SEL3 := 1;
  end if;
  if ngr_anl1 = 4 or ngr_anl2 = 4 or ngr_anl3 = 4 or ngr_anl4 = 4  then
     nANL_SEL4 := 1;
  end if;





  /*       */
  delete from parus.yprepos01
  where authid = user;
  commit;


  --  
  begin
    select 1
    into check1
    from parus.valturns VT
    where VT.ident = nident
      and (nvl(nPRINTSELECT,0) = 0
       or  exists (select null
                   from selectlist Sl
                   where Sl.ident = nSELECT
                     and Sl.document = VT.RN))
       and vt.jur_pers is null
       and rownum < 2;
    exception
    when OTHERS then
       check1 := 0;
  end;
  if nvl(check1,0) = 1 then
     p_exception(0,'         ');
  end if;


 /* begin
    select 1
    into check2
    from parus.valturns VT
    where VT.ident = nident
      and (nvl(nPRINTSELECT,0) = 0
       or  exists (select null
                   from selectlist Sl
                   where Sl.ident = nSELECT
                     and Sl.document = VT.RN))
       and vt.analytic1 is not null
       and rownum < 2;
    exception
    when OTHERS then
       check2 := 0;
  end;

  if nvl(check2,0) <>  1 then
     p_exception(0,'      c   1-  ');
  end if;
*/
  /*
  begin
    select 1
    into check3
    from parus.valturns VT
    where VT.ident = nident
      and (nvl(nPRINTSELECT,0) = 0
       or  exists (select null
                   from selectlist Sl
                   where Sl.ident = nSELECT
                     and Sl.document = VT.RN))
       and (vt.analytic2 is not null or vt.analytic3 is not null or vt.analytic4 is not null or vt.analytic5 is not null)
       and rownum < 2;
    exception
    when OTHERS then
       check3 := 0;
  end;
  if nvl(check3,0)  = 1 then
     p_exception(0,'      c    1-  ');
  end if;
  */

  ---

  for recTMC in (select VT.*, dn.nomen_code
                    from parus.valturns VT,
                         dicnomns dn
                   where VT.ident = nident
                     and VT.NOMENCLATURE = dn.rn
                     and (nvl(nPRINTSELECT,0) = 0
                          or  exists (select null
                                      from selectlist Sl
                                      where Sl.ident = nSELECT
                                        and Sl.document = VT.RN))
                     and exists(select null
                                from dicaccs RT
                                where RT.RN = VT.ACCOUNT
                                  and RT.Acc_Form <> 100))
  loop

           insert into YPREPOS01
              (AUTHID,
               RN,
               JUR_PERS,
               DATE_FROM,
               DATE_TO,
               ACCOUNT,
               ANALYTIC1,
               NOMENCLATURE,
               ACNT_REMN_QUANT,
               ACNT_REMN_SUM,
               ACNT_DEBIT_TURN_QUANT,
               ACNT_DEBIT_TURN_SUM,
               ACNT_CREDIT_TURN_QUANT,
               ACNT_CREDIT_TURN_SUM,
               inum,
               MODEL,
               DATEIN,
               AGENT)
            values
              (user,
               recTMC.rn,
               recTMC.Jur_Pers,
               recTMC.Date_From,
               recTMC.Date_To,
               recTMC.Account,
               recTMC.Analytic1,
               recTMC.Nomenclature,
               recTMC.ACNT_REMN_QUANT,
               recTMC.ACNT_REMN_SUM,
               recTMC.ACNT_DEBIT_TURN_QUANT,
               recTMC.ACNT_DEBIT_TURN_SUM,
               recTMC.ACNT_CREDIT_TURN_QUANT,
               recTMC.ACNT_CREDIT_TURN_SUM,
               recTMC.nomen_code,
               null,
               null,
               recTMC.Agent);
          commit;
  end loop;

  /*
  for recTMC in (select VT.*, dn.nomen_code
                    from parus.valturns VT,
                         dicnomns dn
                   where VT.ident = nident
                     and VT.NOMENCLATURE = dn.rn
                     and (nvl(nPRINTSELECT,0) = 0
                          or  exists (select null
                                      from selectlist Sl
                                      where Sl.ident = nSELECT
                                        and Sl.document = VT.RN))
                     )
  loop

           insert into YPREPOS01_TMP1
              (AUTHID,
               RN,
               JUR_PERS,
               DATE_FROM,
               DATE_TO,
               ACCOUNT,
               ANALYTIC1,
               NOMENCLATURE,
               ACNT_REMN_QUANT,
               ACNT_REMN_SUM,
               ACNT_DEBIT_TURN_QUANT,
               ACNT_DEBIT_TURN_SUM,
               ACNT_CREDIT_TURN_QUANT,
               ACNT_CREDIT_TURN_SUM,
               inum,
               MODEL,
               DATEIN,
               AGENT)
            values
              (user,
               recTMC.rn,
               recTMC.Jur_Pers,
               recTMC.Date_From,
               recTMC.Date_To,
               recTMC.Account,
               recTMC.Analytic1,
               recTMC.Nomenclature,
               recTMC.ACNT_REMN_QUANT,
               recTMC.ACNT_REMN_SUM,
               recTMC.ACNT_DEBIT_TURN_QUANT,
               recTMC.ACNT_DEBIT_TURN_SUM,
               recTMC.ACNT_CREDIT_TURN_QUANT,
               recTMC.ACNT_CREDIT_TURN_SUM,
               recTMC.nomen_code,
               null,
               null,
               recTMC.Agent);
          commit;
  end loop;
*/

  --     ***     
  for recMAIN in (select VT.*, nvl(d1,vt.date_from) as date_from1, nvl(d2,vt.date_to) as date_to1
                    from parus.valturns VT
                   where VT.ident = nident
                     and (nvl(nPRINTSELECT,0) = 0
                          or  exists (select null
                                      from selectlist Sl
                                      where Sl.ident = nSELECT
                                        and Sl.document = VT.RN))
                     and (nvl(VT.ACNT_REMN_SUM,0) <> 0 or nvl(VT.ACNT_REMN_QUANT,0) <> 0) ---108140   0,  -  0
                     and exists(select null
                                from dicaccs RT
                                where RT.RN = VT.ACCOUNT
                                  and RT.Acc_Form = 100)
   ) loop



    --         ****     
    for recSPEC1 in (select H.PRN,
                            max(H.NUMB) as rnNUMB,
--                            MAX(H.RN) as RNOPER,
                            max(H.ACTION_DATE) as dateM,
                            I.INV_NUMB_SIGN,
                            I.CARD_TYPE
                       from parus.invhist H,
                            parus.inventory I
                      where I.RN = H.PRN
                        and I.NOMENCLATURE = recMAIN.Nomenclature
                        and I.Jur_Pers = recMAIN.Jur_Pers
                        and H.NEW_ACCOUNT = recMAIN.Account
                        and (nvl(H.ANL_NEW1,0) = nvl(recMAIN.Analytic1,0) or nANL_SEL1 = 0)
                        and (nvl(H.ANL_NEW2,0) = nvl(recMAIN.Analytic2,0) or nANL_SEL2 = 0)
                        and (nvl(H.ANL_NEW3,0) = nvl(recMAIN.Analytic3,0) or nANL_SEL3 = 0)
                        and (nvl(H.ANL_NEW4,0) = nvl(recMAIN.Analytic4,0) or nANL_SEL4 = 0)
                        and (H.Agent_To = recMAIN.Agent
                             or
                            (H.Agent_from = recMAIN.Agent
                             and H.ACTION_TYPE in (9,10)
                             and H.COUNT_NEW < H.COUNT_OLD
                             and NVL(H.COUNT_NEW,0) > 0))
                        and H.ACTION_DATE < recMAIN.Date_From1
                      group by H.PRN, I.Inv_Numb_Sign, I.CARD_TYPE) loop
--p_exception(0,recMAIN.Nomenclature||'|'||recMAIN.Jur_Pers||'|'||recMAIN.Account||'|'||recMAIN.Analytic1||'|'||recMAIN.Agent||'|'||recMAIN.Date_From1);
      begin
        select h1.rn
        into nRNOPER
        from invhist h1
        where h1.prn = recSPEC1.Prn
          and h1.numb = recSPEC1.Rnnumb;
        exception
        when OTHERS then
           nRNOPER := null;
      end;


      /*           */
      ---     
      begin
        select count(H.RN)
          into nDEL
          from parus.invhist H
         where H.PRN = recSPEC1.Prn
           and (not (H.Agent_To = recMAIN.Agent) or not (H.NEW_ACCOUNT = recMAIN.account)
                or (nANL_SEL1 = 0 and not (nvl(H.Anl_New1,0) = nvl(recMAIN.Analytic1,0)))
                or (nANL_SEL2 = 0 and not (nvl(H.Anl_New2,0) = nvl(recMAIN.Analytic2,0)))
                or (nANL_SEL3 = 0 and not (nvl(H.Anl_New3,0) = nvl(recMAIN.Analytic3,0)))
                or (nANL_SEL4 = 0 and not (nvl(H.Anl_New4,0) = nvl(recMAIN.Analytic4,0)))

              )
           and (H.new_a_cost_begin = H.old_a_cost_begin)
           and (H.Count_Old = H.Count_New)
           and H.NUMB > recSPEC1.Rnnumb
           and H.Action_Date < recMAIN.Date_From1;
      exception
        when OTHERS then
          nDEL := 0;
      end;

     
      

      --   

      if nvl(nDEL,0) = 0 then
        begin
          select count(H.RN)
            into nDEL
            from parus.invhist H
           where H.PRN = recSPEC1.Prn
             and H.ACTION_TYPE = 4
             and H.Action_Date < recMAIN.Date_From1;
        exception
          when OTHERS then
            nDEL := 0;
        end;
      end if;


      ------   ,         
      if nvl(nDEL,0) = 0  then
--      recSPEC1.Inv_Numb_Sign = 1 and
          begin
            select count(H.RN)
              into nDEL
              from parus.invhist H
             where H.prn = recSPEC1.Prn
               and H.Action_Type in  (9, 10)
               and H.ACTION_DATE >= recMAIN.Date_From1
               and exists (select rn
                           from doclinks S
                           where S.OUT_DOCUMENT = recSPEC1.Prn
                             and (S.In_Unitcode  = 'Inventory' or S.In_Unitcode = 'InventoryHistory')
                             and S.Out_Unitcode = 'Inventory');
          exception
            when OTHERS then
              nDEL := 0;
          end;
      end if;

      ------   -     
      if nvl(nDEL,0) = 0  then
          begin
            select count(H.RN)
              into nDEL
              from parus.invhist H
             where H.rn = nRNOPER
               and H.Action_Type in  (9, 10)
               and H.AGENT_TO = recMAIN.AGENT
               ---92745 ??? account analityc1
               and exists (select rn
                           from doclinks S
                           where S.IN_DOCUMENT = H.rn
                             and S.In_Unitcode  = 'InventoryHistory'
                             and S.Out_Unitcode = 'Inventory');
          exception
            when OTHERS then
              nDEL := 0;
          end;
      end if;
   if nvl(nDEL,0) = 0 then ---131821 (    )
      begin
         select h.prn
           into nDEL
           from invhist h
          where h.prn =recSPEC1.Prn
            and h.numb > recSPEC1.Rnnumb
            and h.action_date <= recMAIN.Date_From1
       group by h.prn;
     exception
     when others then
       nDEL:=0;
     end;
    end if;

--p_exception(0,nDEL||'|'||recSPEC1.Prn||'|'||recSPEC1.Rnnumb);


      if  nvl(nDEL,0) = 0   then    --      -  

        if recSPEC1.Inv_Numb_Sign = 1 then
          nTMP_SUMI := 0;
          --                    
          for recSPEC2 in (select H.New_a_Cost_Begin,
                                  H.Count_New,
                                  H.ACTION_TYPE,
                                  I.RN,
                                  P.RN as RNSPEC,
                                  P.IN_DATE,
                                  P.INV_GROUP,
                                  P.INV_NUMB,
                                  P.INCOME_SUM_A,
                                  P.Item_Count,
                                  I.Object_Note
                             from parus.invhist   H,
                                  parus.inventory I,
                                  parus.invpack   P
                            where I.RN = H.PRN
                              and P.PRN = I.RN
                              and P.IN_DATE < recMAIN.Date_From1
                              and (P.Out_Date >= recMAIN.Date_From1 or
                                   P.Out_Date is NULL)
                              and H.rn = nRNOPER) loop


            sINVNUMB := f_ypgetlinenumb(recSPEC2.INV_GROUP, recSPEC2.INV_NUMB);
            if recSPEC2.item_count <> 0 or recSPEC2.income_sum_a <> 0 then
                if recSPEC1.card_type = 2 and recSPEC2.income_sum_a = 0 then
                   if recSPEC2.Count_New <> 0 then
                      sum_insh1 :=  recSPEC2.New_a_Cost_Begin/recSPEC2.Count_New;
                      nTMP_SUMI := nTMP_SUMI + recSPEC2.New_a_Cost_Begin/recSPEC2.Count_New;
                   else
                      sum_insh1 :=  0;
                   end if;
                else
                   sum_insh1 := recSPEC2.income_sum_a;
                end if;
                rn_recsp := recSPEC2.Rnspec;
                nTMP_SUMA := recSPEC2.New_a_Cost_Begin;
                insert into YPREPOS01
                  (AUTHID,
                   RN,
                   JUR_PERS,
                   DATE_FROM,
                   DATE_TO,
                   ACCOUNT,
                   ANALYTIC1,
                   ANALYTIC2,
                   ANALYTIC3,
                   ANALYTIC4,
                   NOMENCLATURE,
                   ACNT_REMN_QUANT,
                   ACNT_REMN_SUM,
                   inum,
                   RNSPEC,
                   MODEL,
                   DATEIN,
                   agent)
                values
                  (user,
                   recSPEC2.rn,
                   recMAIN.Jur_Pers,
                   recMAIN.Date_From1,
                   recMAIN.Date_To1,
                   recMAIN.Account,
                   recMAIN.Analytic1,
                   recMAIN.Analytic2,
                   recMAIN.Analytic3,
                   recMAIN.Analytic4,
                   recMAIN.Nomenclature,
                   recSPEC2.item_count,
                   sum_insh1,
                   sINVNUMB,
                   recSPEC2.Rnspec,
                   recSPEC2.Object_Note,
                   recSPEC2.In_Date,
                   recMAIN.agent);

              end if;
          end loop;

          if nTMP_SUMI <> nTMP_SUMA and nTMP_SUMA-nTMP_SUMI between -10 and 10 then
             update YPREPOS01 t
             set t.acnt_remn_sum = t.acnt_remn_sum + nTMP_SUMA - nTMP_SUMI
             where t.authid = user
               and t.rnspec = rn_recsp;
          end if;

          commit;

        else

          --    

          for recSPEC2 in (select H.New_a_Cost_Begin,
                                  H.Count_New,
                                  H.ACTION_TYPE,
                                  I.RN,
                                  I.OBJECT_GROUP,
                                  I.OBJECT_NUMBER,
                                  I.INCOME_DATE,
                                  I.OBJECT_NOTE,
                                  H.NEW_A_AMORT_DURING,
                                  H.NEW_A_AMORT_BEGIN
                             from parus.invhist H, parus.inventory I
                            where I.RN = H.PRN
                              and H.rn = nRNOPER) loop

            sINVNUMB := f_ypgetlinenumb(recSPEC2.Object_Group, recSPEC2.Object_Number);
            if recSPEC2.Count_New <> 0 or recSPEC2.New_a_Cost_Begin <> 0 then

            insert into YPREPOS01
              (AUTHID,
               RN,
               JUR_PERS,
               DATE_FROM,
               DATE_TO,
               ACCOUNT,
               ANALYTIC1,
               ANALYTIC2,
               ANALYTIC3,
               ANALYTIC4,
               NOMENCLATURE,
               ACNT_REMN_QUANT,
               ACNT_REMN_SUM,
               inum,
               MODEL,
               DATEIN,
               AGENT)
            values
              (user,
               recSPEC2.rn,
               recMAIN.Jur_Pers,
               recMAIN.Date_From1,
               recMAIN.Date_To1,
               recMAIN.Account,
               recMAIN.Analytic1,
               recMAIN.Analytic2,
               recMAIN.Analytic3,
               recMAIN.Analytic4,
               recMAIN.Nomenclature,
               recSPEC2.Count_New,
               recSPEC2.New_a_Cost_Begin,
               sINVNUMB,
               recSPEC2.Object_Note,
               recSPEC2.Income_Date,
               recMAIN.Agent);
          end if;
          end loop;
          commit;
        end if;
      end if;
    end loop;
  end loop;

  ---    

  ---    
  for recDB in (select VT.*,nvl(d1,vt.date_from) as date_from1, nvl(d2,vt.date_to) as date_to1
                    from parus.valturns VT
                   where VT.ident = nident
                     and (nvl(nPRINTSELECT,0) = 0
                          or  exists (select null
                                      from selectlist Sl
                                      where Sl.ident = nSELECT
                                        and Sl.document = VT.RN))
                     and (nvl(VT.acnt_debit_turn_sum,0) <> 0 or nvl(VT.Acnt_Debit_Turn_Quant,0) <> 0) ---108140   0,  -  0
                     and exists(select null
                                from dicaccs RT
                                where RT.RN = VT.ACCOUNT
                                  and RT.Acc_Form = 100)
                     )
  loop


    for recXO in (select XOS.RN, XOS.Prn, SUM(XOS.Acnt_Sum) as sumi
                    from OPRSPECS XOS, ECONOPRS XOH
                   where XOS.Prn = XOH.Rn
                     and XOH.OPERATION_DATE BETWEEN recDB.Date_From1 and recDB.Date_To1
                     and XOH.Agent_To = recDB.Agent
                     and XOS.Account_Debit = recDB.Account
                     and (nvl(XOS.Analytic_Debit1,0) = nvl(recDB.Analytic1,0) or nANL_SEL1 = 0)
                     and (nvl(XOS.Analytic_Debit2,0) = nvl(recDB.Analytic2,0) or nANL_SEL2 = 0)
                     and (nvl(XOS.Analytic_Debit3,0) = nvl(recDB.Analytic3,0) or nANL_SEL3 = 0)
                     and (nvl(XOS.Analytic_Debit4,0) = nvl(recDB.Analytic4,0) or nANL_SEL4 = 0)
                     and XOS.NOMENCLATURE = recDB.Nomenclature
                     and XOH.JUR_PERS = recDB.Jur_Pers
                  group by XOS.RN, XOS.Prn) loop

      if nvl(recXO.sumi,0)<0 then
         nZNAK := -1;
      else
         nZNAK := 1;
      end if;

      for recSPEC in (select H.OLD_A_COST_BEGIN,
                             H.New_a_Cost_Begin,
                             H.Count_Old,
                             H.count_new,
                             H.Action_Date,
                             I.rn,
                             I.Object_Group,
                             I.Object_Number,
                             I.Object_Note,
                             I.Income_Date,
                             I.Inv_Numb_Sign,
                             H.AGENT_FROM,
                             H.Agent_To,
                             H.Action_Type,
                             H.RN as rnhist
                        from DOCLINKS L, Invhist H, Inventory I
                       where L.OUT_UNITCODE = 'EconomicOperationsSpecs' -- -87306 EconomicOperations - > EconomicOperationsSpecs
                         and L.OUT_DOCUMENT = recXO.Rn                  -- -87306 recXO.Prn -> recXO.Rn
                         and L.IN_UNITCODE = 'InventoryHistory'
                         and L.IN_DOCUMENT = H.Rn
                         and H.Prn = I.Rn
                         and I.NOMENCLATURE = recDB.Nomenclature
                         and I.Jur_Pers = recDB.Jur_Pers
                         and H.AGENT_TO = recDB.Agent
                         and H.NEW_ACCOUNT = recDB.Account
                         and (nvl(H.ANL_NEW1,0) = nvl(recDB.Analytic1,0) or nANL_SEL1 = 0)
                         and (nvl(H.ANL_NEW2,0) = nvl(recDB.Analytic2,0) or nANL_SEL2 = 0)
                         and (nvl(H.ANL_NEW3,0) = nvl(recDB.Analytic3,0) or nANL_SEL3 = 0)
                         and (nvl(H.ANL_NEW4,0) = nvl(recDB.Analytic4,0) or nANL_SEL4 = 0)
                         )
       loop
        ---   -        
        nDEL := 0;
        if recSPEC.Action_Type = 9 and recSPEC.count_new <> recSPEC.count_old then

                nDEL := 1;
                for recSPEC2 in (select H.RN as rncard,
                                        H.OBJECT_GROUP,
                                        H.OBJECT_number
                                 from parus.inventory H
                                 where exists(select null
                                              from DOCLINKS Dl
                                              where DL.IN_DOCUMENT = recSPEC.rnHIST
                                                and DL.Out_Document = H.RN
                                                and IN_UNITCODE='InventoryHistory'
                                                and OUT_UNITCODE='Inventory'))
                loop

                                sINVNUMB := f_ypgetlinenumb(recSPEC2.Object_Group, recSPEC2.Object_Number);
                                insert into YPREPOS01
                                  (AUTHID,
                                   RN,
                                   JUR_PERS,
                                   DATE_FROM,
                                   DATE_TO,
                                   ACCOUNT,
                                   ANALYTIC1,
                                   ANALYTIC2,
                                   ANALYTIC3,
                                   ANALYTIC4,
                                   NOMENCLATURE,
                                   ACNT_DEBIT_TURN_QUANT,
                                   ACNT_DEBIT_TURN_SUM,
                                   inum,
                                   MODEL,
                                   DATEIN,
                                   AGENT,
                                   Rnspec)
                                values
                                  (user,
                                   recSPEC2.rncard,
                                   recDB.Jur_Pers,
                                   recDB.Date_From1,
                                   recDB.Date_To1,
                                   recDB.Account,
                                   recDB.Analytic1,
                                   recDB.Analytic2,
                                   recDB.Analytic3,
                                   recDB.Analytic4,
                                   recDB.Nomenclature,
                                   nZNAK*(recSPEC.count_old-recSPEC.count_new),
                                   nZNAK*(recSPEC.OLD_A_COST_BEGIN - recSPEC.NEW_A_COST_BEGIN),
                                   sINVNUMB,
                                   recSPEC.Object_Note,
                                   recSPEC.Income_Date,
                                   recDB.Agent,
                                   0);
                                commit;
                end loop;
        end if;


        if nvl(nDEL,0) = 0  then
          -- *******    
          begin
            select rn
              into nINSERT
              from YPREPOS01
             where YPREPOS01.RN = recSPEC.RN
               and YPREPOS01.Agent = recDB.Agent
               and YPREPOS01.Analytic1 = recDB.Analytic1 ---92745
               and YPREPOS01.Account = recDB.Account ---92745
               and YPREPOS01.Authid = user;
          exception
            when OTHERS then
              nINSERT := 0;
          end;

          if (recSPEC.Count_New - recSPEC.count_old = 0) and (recSpec.New_a_Cost_Begin - recSPEC.Old_a_Cost_Begin = 0) then

            if nvl(nINSERT,0) = 0 then

              ---       
              if recSPEC.Inv_Numb_Sign = 1 then
                ----  
                for recSPEC2 in (select P.RN as RNSPEC,
                                        P.IN_DATE,
                                        P.INV_GROUP,
                                        P.INV_NUMB,
                                        P.INCOME_SUM_A,
                                        P.Item_Count
                                   from parus.invpack P
                                  where P.PRN = recSPEC.RN
                                    and P.IN_DATE <= recDB.Date_to1
                                    and (P.Out_Date >= recDB.Date_from1 or
                                        P.Out_Date is NULL))
                loop


                  sINVNUMB := f_ypgetlinenumb(recSPEC2.Inv_Group, recSPEC2.Inv_Numb);

                  insert into YPREPOS01
                    (AUTHID,
                     RN,
                     JUR_PERS,
                     DATE_FROM,
                     DATE_TO,
                     ACCOUNT,
                     ANALYTIC1,
                     ANALYTIC2,
                     ANALYTIC3,
                     ANALYTIC4,
                     NOMENCLATURE,
                     ACNT_DEBIT_TURN_QUANT,
                     ACNT_DEBIT_TURN_SUM,
                     inum,
                     MODEL,
                     DATEIN,
                     AGENT,
                     Rnspec)
                  values
                    (user,
                     recSPEC.rn,
                     recDB.Jur_Pers,
                     recDB.Date_From1,
                     recDB.Date_To1,
                     recDB.Account,
                     recDB.Analytic1,
                     recDB.Analytic2,
                     recDB.Analytic3,
                     recDB.Analytic4,
                     recDB.Nomenclature,
                     nZNAK*recSPEC2.Item_Count,
                     nZNAK*recSpec2.Income_Sum_a,
                     sINVNUMB,
                     recSPEC.Object_Note,
                     recSPEC.Income_Date,
                     recDB.Agent,
                     recSPEC2.Rnspec);
                  commit;

                end loop;

              else
                -------   
                sINVNUMB := f_ypgetlinenumb(recSPEC.Object_Group, recSPEC.Object_Number);
                insert into YPREPOS01
                  (AUTHID,
                   RN,
                   JUR_PERS,
                   DATE_FROM,
                   DATE_TO,
                   ACCOUNT,
                   ANALYTIC1,
                   ANALYTIC2,
                   ANALYTIC3,
                   ANALYTIC4,
                   NOMENCLATURE,
                   ACNT_DEBIT_TURN_QUANT,
                   ACNT_DEBIT_TURN_SUM,
                   inum,
                   MODEL,
                   DATEIN,
                   AGENT)
                values
                  (user,
                   recSPEC.rn,
                   recDB.Jur_Pers,
                   recDB.Date_From1,
                   recDB.Date_To1,
                   recDB.Account,
                   recDB.Analytic1,
                   recDB.Analytic2,
                   recDB.Analytic3,
                   recDB.Analytic4,
                   recDB.Nomenclature,
                   nZNAK*recSPEC.Count_New,
                   nZNAK*recSpec.New_a_Cost_Begin,
                   sINVNUMB,
                   recSPEC.Object_Note,
                   recSPEC.Income_Date,
                   recDB.Agent);

              end if;
            else
              update YPREPOS01
                 set ACNT_DEBIT_TURN_QUANT = nZNAK*(YPREPOS01.ACNT_DEBIT_TURN_QUANT +
                                             recSPEC.Count_New),
                     ACNT_DEBIT_TURN_SUM   = nZNAK*(YPREPOS01.ACNT_DEBIT_TURN_SUM +
                                             recSpec.New_a_Cost_Begin)
               where YPREPOS01.Rn = nINSERT
                 and YPREPOS01.Agent = recDB.Agent
                 and YPREPOS01.Account = recDB.Account ---92745
                 and YPREPOS01.Analytic1 = recDB.Analytic1 ---92745
                 and YPREPOS01.Authid = user;
            end if;
          else

            if nvl(nINSERT,0) = 0  then

              sINVNUMB := f_ypgetlinenumb(recSPEC.Object_Group, recSPEC.Object_Number);
              insert into YPREPOS01
                (AUTHID,
                 RN,
                 JUR_PERS,
                 DATE_FROM,
                 DATE_TO,
                 ACCOUNT,
                 ANALYTIC1,
                 ANALYTIC2,
                 ANALYTIC3,
                 ANALYTIC4,
                 NOMENCLATURE,
                 ACNT_DEBIT_TURN_QUANT,
                 ACNT_DEBIT_TURN_SUM,
                 inum,
                 MODEL,
                 DATEIN,
                 AGENT)
              values
                (user,
                 recSPEC.rn,
                 recDB.Jur_Pers,
                 recDB.Date_From1,
                 recDB.Date_To1,
                 recDB.Account,
                 recDB.Analytic1,
                 recDB.Analytic2,
                 recDB.Analytic3,
                 recDB.Analytic4,
                 recDB.Nomenclature,
                 nZNAK*(recSPEC.Count_New - recSPEC.count_old),
                 nZNAK*(recSpec.New_a_Cost_Begin - recSPEC.Old_a_Cost_Begin),
                 sINVNUMB,
                 recSPEC.Object_Note,
                 recSPEC.Income_Date,
                 recDB.Agent);
            else
              update YPREPOS01
                 set ACNT_DEBIT_TURN_QUANT = YPREPOS01.ACNT_DEBIT_TURN_QUANT +
                                             nZNAK*(recSPEC.Count_New -
                                             recSPEC.count_old),
                     ACNT_DEBIT_TURN_SUM   = YPREPOS01.ACNT_DEBIT_TURN_SUM +
                                             nZNAK*(recSpec.New_a_Cost_Begin -
                                             recSPEC.Old_a_Cost_Begin)
               where YPREPOS01.Rn = nINSERT
                 and YPREPOS01.Account = recDB.Account ---92745
                 and YPREPOS01.Analytic1 = recDB.Analytic1 ---92745
                 and YPREPOS01.Agent = recDB.Agent
                 and YPREPOS01.Authid = user;
            end if;

          end if;

          commit;
        end if;
      end loop;

    end loop;

  end loop;

  ---      

  ---          
  for rec in (select T.*, H.RN as RNH
              from YPREPOS01 T,
                   inventory I,
                   invhist H
              where T.AUTHID = user
                and T.RN = I.RN
                and I.Card_Type = 3
                and H.prn = I.rn
                and H.Action_Type = 16
                and H.Action_Date <= T.DATE_TO
                and not exists(select null
                                from doclinks Dl
                                where Dl.In_Document = H.Rn
                                  and Dl.Out_Unitcode = 'EconomicOperations')
                                  )
   loop


           for rec2 In (select Dl.Out_Document, I.Object_Group, I.Object_Number, I.RN
                        from  inventory I,
                              doclinks Dl
                        where Dl.In_Unitcode = 'InventoryHistory'
                          and Dl.In_Document = rec.rnh
                          and Dl.Out_Unitcode = 'Inventory'
                          and dl.out_document = I.Rn)
           loop
               sINVNUMB := f_ypgetlinenumb(rec2.object_group, rec2.object_number);
               update yprepos01 T
               set T.rn = rec2.rn,
                   T.INUM = sINVNUMB
               where T.RN = rec.rn;
--                 and nvl(T.Acnt_Remn_Sum,0) <> 0
--                 or nvl(T.ACNT_REMN_QUANT,0) <> 0;
               commit;


           end loop;

   end loop;


--  if false then


  ---   






  ---    

  for recCR in (select VT.*, nvl(d1,vt.date_from) as date_from1, nvl(d2,vt.date_to) as date_to1
                    from parus.valturns VT
                   where VT.ident = nident
                     and (nvl(nPRINTSELECT,0) = 0
                          or  exists (select null
                                      from selectlist Sl
                                      where Sl.ident = nSELECT
                                        and Sl.document = VT.RN))
                     and (nvl(VT.ACNT_CREDIT_TURN_SUM,0) <> 0 or nvl(VT.ACNT_CREDIT_TURN_QUANT,0) <> 0) ---108140   0,  -  0
                     and exists(select null
                                from dicaccs RT
                                where RT.RN = VT.ACCOUNT
                                  and RT.Acc_Form = 100)
                     )

  loop



    for recXO in (select /*max(XOS.RN) as RN,
                         XOS.Prn,
                         XOH.Agent_From,
                         XOH.Jur_Pers,
                         XOS.Nomenclature,*/ -- -87306
                         XOS.RN, XOS.Prn,    -- -87306
                         sum(XOS.Acnt_Sum) as sumi
                    from OPRSPECS XOS, ECONOPRS XOH
                   where XOS.Prn = XOH.Rn
                     and XOH.OPERATION_DATE BETWEEN recCR.Date_From1 and recCR.Date_To1
                     and XOH.Agent_from = recCR.Agent
                     and XOS.account_credit = recCR.Account
                     and (nvl(XOS.Analytic_credit1,0) = nvl(recCR.Analytic1,0) or nANL_SEL1 = 0)
                     and (nvl(XOS.Analytic_credit2,0) = nvl(recCR.Analytic2,0) or nANL_SEL2 = 0)
                     and (nvl(XOS.Analytic_credit3,0) = nvl(recCR.Analytic3,0) or nANL_SEL3 = 0)
                     and (nvl(XOS.Analytic_credit4,0) = nvl(recCR.Analytic4,0) or nANL_SEL4 = 0)
                     and XOS.NOMENCLATURE = recCR.Nomenclature
                     and XOH.JUR_PERS = recCr.Jur_Pers
                   group by /*XOH.Agent_From,
                            XOH.Jur_Pers,
                            XOS.Nomenclature,*/ -- -87306
                            XOS.RN,             -- -87306
                            XOS.Prn)
     loop

      if nvl(recXO.sumi,0)<0 then
         nZNAK := -1;
      else
         nZNAK := 1;
      end if;


      for recSPEC in (select H.OLD_A_COST_BEGIN,
                             H.New_a_Cost_Begin,
                             H.Count_Old,
                             H.count_new,
                             I.rn,
                             I.Object_Group,
                             I.Object_Number,
                             I.Object_Note,
                             I.Income_Date,
                             H.NEW_ACCOUNT,
                             H.Agent_from,
                             I.INV_NUMB_SIGN,
                             H.RN as RNHIST
                        from DOCLINKS L, Invhist H, Inventory I
                       where L.OUT_UNITCODE = 'EconomicOperationsSpecs' -- -87306 EconomicOperations - > EconomicOperationsSpecs
                         and L.OUT_DOCUMENT = recXO.Rn                  -- -87306 recXO.Prn -> recXO.Rn
                         and L.IN_UNITCODE = 'InventoryHistory'
                         and L.IN_DOCUMENT = H.Rn
                         and H.Prn = I.Rn
                      )
      loop

        nDEL := 0;

        begin
          select count(P.rn)
            into nDEL
            from invpack P
           where P.Prn = recSPEC.rn
             and P.IN_DATE <= recCR.Date_To
             and (P.OUT_DATE >= recCR.Date_From or P.Out_Date is NULL);
        exception
          when OTHERS then
            nDEL := 0;
        end;

        if nvl(nDEL,0) > 0 and recSPEC.INV_NUMB_SIGN = 0 then
          nDEL:= 0;
        end if;

        if nvl(nDEL,0) = 0  then
          if (recSPEC.Count_New - recSPEC.count_old = 0) and (recSpec.New_a_Cost_Begin - recSpec.old_a_Cost_Begin = 0) then

            update YPREPOS01
               set ACNT_CREDIT_TURN_QUANT = YPREPOS01.Acnt_Credit_Turn_Quant +
                                            nZNAK*recSPEC.Count_old,
                   ACNT_CREDIT_TURN_SUM   = YPREPOS01.Acnt_Credit_Turn_Sum +
                                            nZNAK*recSpec.OLD_a_Cost_Begin
             where YPREPOS01.Rn = recSPEC.RN
               and YPREPOS01.Account = recCR.Account ---92745
               and nvl(YPREPOS01.Analytic1, 0) = nvl(recCR.Analytic1, 0) ---92745
               and YPREPOS01.agent = recCR.Agent
               and YPREPOS01.Authid = user;
            commit;

          else

            update YPREPOS01
               set ACNT_CREDIT_TURN_QUANT = YPREPOS01.Acnt_Credit_Turn_Quant +
                                            (-1) * nZNAK * (recSPEC.Count_New -
                                            recSPEC.count_old),
                   ACNT_CREDIT_TURN_SUM   = YPREPOS01.ACNT_CREDIT_TURN_SUM +
                                            (-1) * nZNAK * (recSpec.New_a_Cost_Begin -
                                            recSPEC.Old_a_Cost_Begin)
             where YPREPOS01.Rn = recSPEC.RN
               and YPREPOS01.agent = recCR.Agent
               and YPREPOS01.Account = recCR.Account ---92745
               and nvl(YPREPOS01.Analytic1, 0) = nvl(recCR.Analytic1, 0) ---92745
               and YPREPOS01.Authid = user;

          end if;

        else
        ---    
        ---  - 
            begin
              select L.IN_DOCUMENT as RNSPIS
              into nPRNSPIS
              from DOCLINKS L
              where L.OUT_UNITCODE = 'InventoryHistory'
                and L.OUT_DOCUMENT = recSPEC.RNHIST
                and L.IN_UNITCODE = 'InventoryGroupCardSheet';
              exception
              when OTHERS then
                   nPRNSPIS := 0;
            end;

            if nPRNSPIS > 0 then

                  for recSPIS in (select L.IN_DOCUMENT as RNSPIS
                                    from DOCLINKS L
                                   where L.OUT_UNITCODE = 'InventoryHistory'
                                     and L.OUT_DOCUMENT = recSPEC.RNHIST
                                     and L.IN_UNITCODE = 'InventoryGroupCardSheet') loop

                          if (recSPEC.Count_New - recSPEC.count_old = 0) and
                             (recSpec.New_a_Cost_Begin - recSpec.old_a_Cost_Begin = 0) then

                            update YPREPOS01
                               set ACNT_CREDIT_TURN_QUANT = YPREPOS01.Acnt_Credit_Turn_Quant + nZNAK*1,
                                   ACNT_CREDIT_TURN_SUM   = YPREPOS01.ACNT_CREDIT_TURN_SUM +
                                                            nZNAK*nvl(recSpec.New_a_Cost_Begin /
                                                                nvl(recSPEC.Count_New,1),
                                                                0)
                             where YPREPOS01.Rn = recSPEC.RN
                               and YPREPOS01.agent = recCR.Agent
                               ---92745 ??? account analityc1
                               and YPREPOS01.Authid = user
                               and YPREPOS01.RNSPEC = recSPIS.RNSPIS;
                          else
                               update YPREPOS01 S
                               set S.Acnt_Credit_Turn_Quant = NVL(S.Acnt_Remn_Quant,0)+nvl(s.acnt_debit_turn_quant,0),
                                   S.ACNT_CREDIT_TURN_SUM   = NVL(S.ACNT_REMN_SUM,0)+NVL(s.acnt_debit_turn_sum,0)
                               where S.RN = recSPEC.rn
                                 and S.Agent = recCR.Agent
                                 ---92745 ??? account analityc1
                                 and S.Authid = user
                                 and S.Rnspec = recSPIS.rnSPIS;
                          end if;
                  end loop;
          else
                update YPREPOS01
                   set ACNT_CREDIT_TURN_QUANT = YPREPOS01.Acnt_Credit_Turn_Quant+nZNAK*1,
                       ACNT_CREDIT_TURN_SUM   = YPREPOS01.ACNT_CREDIT_TURN_SUM +
                                                nZNAK*nvl(recSpec.New_a_Cost_Begin /
                                                    nvl(recSPEC.Count_old,1),
                                                    0)
                 where YPREPOS01.Rn = recSPEC.RN
                   and YPREPOS01.agent = recCR.Agent
                   and YPREPOS01.Account = recCR.Account ---92745
                   and nvl(YPREPOS01.Analytic1, 0) = nvl(recCR.Analytic1, 0) ---92745
                   and YPREPOS01.Authid = user;
          end if;
          /* -87376 begin */
          nTMP_SUMA := recSpec.New_a_Cost_Begin;

          select nvl(sum(nvl(ACNT_CREDIT_TURN_SUM,0)),0)
            into nTMP_SUMI
            from YPREPOS01
           where YPREPOS01.Rn = recSPEC.RN
             and YPREPOS01.agent = recCR.Agent
             and YPREPOS01.Account = recCR.Account ---92745
             and nvl(YPREPOS01.Analytic1, 0) = nvl(recCR.Analytic1, 0) ---92745
             and YPREPOS01.Authid = user;
          --  
          if nTMP_SUMI <> nTMP_SUMA then
             update YPREPOS01
                set ACNT_CREDIT_TURN_SUM = ACNT_CREDIT_TURN_SUM + nTMP_SUMA - nTMP_SUMI
              where YPREPOS01.Rn = recSPEC.RN
                and YPREPOS01.agent = recCR.Agent
                and YPREPOS01.Account = recCR.Account ---92745
                and nvl(YPREPOS01.Analytic1, 0) = nvl(recCR.Analytic1, 0) ---92745
                and YPREPOS01.Authid = user
                and rownum < 2;
          end if;
          /* -87376 end */
        end if;
        commit;
      end loop;

    end loop;

  end loop;

  ---      

  ---     
  for rec in (select S.*,nvl(d1,s.date_from) as date_from1, nvl(d2, s.date_to) as date_to1,
--                     (NVL(I.A_AMORT_DURING, 0) + NVL(I.a_Amort_Begin, 0)) as IZNOS,
                     (select max(ih.new_a_amort_during+ih.new_a_amort_begin)
                         from invhist ih
                         where ih.prn = s.rn
                           and ih.numb in (select max(ih1.numb)
                                           from invhist ih1
                                           where ih1.prn = s.rn
                                             and ih1.action_date <= nvl(d1,s.date_from))) as IZNOS1,
                     (select max(ih.new_a_amort_during+ih.new_a_amort_begin)
                         from invhist ih
                         where ih.prn = s.rn
                           and ih.numb in (select max(ih1.numb)
                                           from invhist ih1
                                           where ih1.prn = s.rn
                                             and ih1.action_date <= nvl(d2,s.date_to))) as IZNOS3,
                     (select sum(ih.new_a_amort_during-ih.old_a_amort_during+ih.new_a_amort_begin-ih.old_a_amort_begin)
                         from invhist ih
                         where ih.prn = s.rn
                           and ih.action_date between nvl(d1,s.date_from) and nvl(d2, s.date_to)) as IZNOS2,
                      /* -87116 begin */
                      case
                         when exists(select null
                                     from invhist ih3
                                     where ih3.prn = s.rn
                                       and ih3.action_type = 4
                                       and ( (ih3.new_a_amort_during = ih3.old_a_amort_during and ih3.new_a_amort_during > 0)
                                             or
                                             (ih3.new_a_amort_begin = ih3.old_a_amort_begin and ih3.new_a_amort_begin > 0) ---87116
                                           )
                                       and ih3.agent_from = s.agent ---89657 ---89932
                                       and ih3.action_date between nvl(d1,s.date_from) and nvl(d2,s.date_to)) then
                               1
                         else
                               0
                      end as OSS,
                      (select nvl(sum(ih.new_a_amort_begin),0)
                         from invhist ih
                        where ih.prn = s.rn
                          and ih.action_type = 4
                          and ih.new_a_amort_begin = ih.old_a_amort_begin
                          and ih.new_a_amort_begin > 0
                          and ih.action_date between nvl(d1,s.date_from) and nvl(d2,s.date_to)) +
                     (select nvl(sum(ih.new_a_amort_during),0)
                         from invhist ih
                        where ih.prn = s.rn
                          and ih.action_type = 4
                          and ih.new_a_amort_during = ih.old_a_amort_during
                          and ih.new_a_amort_during > 0
                          and ih.action_date between nvl(d1,s.date_from) and nvl(d2,s.date_to)) IZNOS4, ---87116
                     /* -87116 end */
                     (select nvl(sum(
                                   case
                                     when ih.agent_from = s.agent then
                                       (-1)*(ih.new_a_amort_begin+ih.new_a_amort_during)
                                     when ih.agent_to = s.agent then
                                       (ih.new_a_amort_begin+ih.new_a_amort_during)
                                     else
                                       0
                                    end),0)
                         from invhist ih
                        where ih.prn = s.rn
                          and ih.action_type = 3
                          and (ih.agent_from = s.agent or ih.agent_to = s.agent)
                          and ih.action_date between nvl(d1,s.date_from) and nvl(d2,s.date_to)) IZNOS5 ---89657 ---89932
                from yprepos01 S
               where S.authid = user
--                 and S.RN = I.RN
              ) loop
--              p_exception(0,rec.iznos2);
    if (((NVL(REC.ACNT_REMN_SUM, 0) + NVL(REC.ACNT_DEBIT_TURN_SUM, 0) - NVL(REC.ACNT_CREDIT_TURN_SUM, 0)) > 0 and nvl(nAMORTBGN,0) = 0) or
        (NVL(REC.ACNT_REMN_SUM, 0) > 0 and nvl(nAMORTBGN,0) = 1)) and (nvl(rec.IZNOS1,0) > 0 or nvl(rec.IZNOS2,0) <> 0 or nvl(rec.IZNOS3,0) > 0 ) then

     -- p_exception(0,1);

      if rec.rnspec <> 0 then


        update parus.yprepos01 S
           set S.AMORTALL    = REC.ACNT_REMN_SUM + REC.ACNT_DEBIT_TURN_SUM -REC.ACNT_CREDIT_TURN_SUM,
               S.Amortperiod = REC.ACNT_DEBIT_TURN_SUM
         where S.Rn = rec.Rn
           and S.RNSPEC = rec.Rnspec
           ---92745 ??? account analityc1
           and S.Agent = rec.Agent;
      else

        begin
          select recSPEC.New_a_Amort_Begin + recSPEC.New_a_Amort_During
            into nAM1
            from invhist recSPEC
           where recSPEC.prn = rec.RN
             and recSPEC.numb =
                               (select max(h.numb)
                                  from invhist H
                                 where H.PRN = rec.RN
                                   and H.ACTION_DATE < rec.date_from1);

        exception
          when OTHERS then
            nAM1 := 0;
        end;

        begin
          select recSPEC.New_a_Amort_Begin + recSPEC.New_a_Amort_During
            into nAM2
            from invhist recSPEC
           where recSPEC.prn = rec.RN
             and recSPEC.numb =
                               (select max(h.numb)
                                  from invhist H
                                 where H.PRN = rec.RN
                                   and H.ACTION_DATE <= rec.date_to1);

        exception
          when OTHERS then
            nAM2 := 0;
        end;

        if nvl(nAMORTBGN,0) = 0 then
          update parus.yprepos01 S
             set S.AMORTALL = nAM2, S.Amortperiod = nAM2 - nAM1
           where S.Rn = rec.Rn
             and S.Account = rec.Account ---92745
             and S.Analytic1 = rec.Analytic1 ---92745
             and S.Agent = rec.Agent;
        else
          update parus.yprepos01 S
             set S.AMORTALL = nAM1, S.Amortperiod = 0
           where S.Rn = rec.Rn
             and S.Account = rec.Account ---92745
             and S.Analytic1 = rec.Analytic1 ---92745
             and S.Agent = rec.Agent;
        end if;


      end if;

      commit;
    else

      update parus.yprepos01 S
         set S.AMORTALL = 0, S.Amortperiod = 0
       where S.Rn = rec.Rn
         and S.Rnspec = rec.rnspec
         and S.Account = rec.Account ---92745
         and S.Analytic1 = rec.Analytic1 ---92745
         and S.Agent = rec.Agent;

      commit;

    end if;
    /* -87116 begin */
    --- last change for test
    if rec.oss = 1 then
      update parus.yprepos01 S
         set --S.AMORTALL = 0, ---89932 
             --S.Amortperiod = (-1)*S.ACNT_CREDIT_TURN_SUM ---87116
             S.Amortperiod = (-1)*rec.iznos4
       where S.Rn = rec.Rn
         and nvl(S.Rnspec,0) = nvl(rec.rnspec,0)
         and S.Account = rec.Account ---92745
         and S.Analytic1 = rec.Analytic1 ---92745
         and S.Agent = rec.Agent;

    end if;
    /* -89657 begin */
    update parus.yprepos01 S
       set S.Amortperiod = S.Amortperiod+rec.iznos5
     where S.Rn = rec.Rn
       and nvl(S.Rnspec,0) = nvl(rec.rnspec,0)
       and S.Account = rec.Account ---92745
       and S.Analytic1 = rec.Analytic1 ---92745
       and S.Agent = rec.Agent;
    /* -89657 end */ ---89932
    /* -87116 end */

    /* -89932 begin */
    if nvl(nAMORTBGN,0) = 0 then
      null;
    else
      update parus.yprepos01 S
         set S.Amortperiod = 0
       where S.Rn = rec.Rn
         and nvl(S.Rnspec,0) = nvl(rec.rnspec,0)
         and S.Account = rec.Account ---92745
         and S.Analytic1 = rec.Analytic1 ---92745
         and S.Agent = rec.Agent;
    end if;
    /* -89932 end */
  end loop;


--  end if;

  ---  

end;  
  
/
grant execute on P_YPTURNIKCREATE to public;

CREATE OR REPLACE PROCEDURE P_YPTURNIKERROR( nIDENT  in number,
                                             nSELECT in number,
                                             nPRINTSELECT in number,
                                             nCHECKACC  in number /*default 0*/)
as
       nTEMP   number(17);
       nTSUM   number(17,2);
       nTQNT   number(17,3);

       nDEL    number;
       ngr_anl1  number;
       ngr_anl2  number;
       ngr_anl3  number;
       ngr_anl4  number;

       nANL_SEL1 number := 0;
       nANL_SEL2 number := 0;
       nANL_SEL3 number := 0;
       nANL_SEL4 number := 0;

begin

      /*PKG_SESSION_VARS.GET('VALTURNS.GROUP_ANL1',ngr_anl1);
      PKG_SESSION_VARS.GET('VALTURNS.GROUP_ANL2',ngr_anl2);
      PKG_SESSION_VARS.GET('VALTURNS.GROUP_ANL3',ngr_anl3);
      PKG_SESSION_VARS.GET('VALTURNS.GROUP_ANL4',ngr_anl4);*/ ---96786
      begin
        select t.group_analytic1, t.group_analytic2, t.group_analytic3, t.group_analytic4
        into ngr_anl1, ngr_anl2, ngr_anl3, ngr_anl4
        from valturns_param t
        where t.ident = nident
          and t.authid = user;
        exception
        when OTHERS then
        ngr_anl1 := PKG_SESSION_VARS.GET_NUM('VALTURNS.GROUP_ANL1');
        ngr_anl2 := PKG_SESSION_VARS.GET_NUM('VALTURNS.GROUP_ANL2');
        ngr_anl3 := PKG_SESSION_VARS.GET_NUM('VALTURNS.GROUP_ANL3');
        ngr_anl4 := PKG_SESSION_VARS.GET_NUM('VALTURNS.GROUP_ANL4');
      end; ---96786


      if ngr_anl1 = 1 or ngr_anl2 = 1 or ngr_anl3 = 1 or ngr_anl4 = 1  then
         nANL_SEL1 := 1;
      end if;
      if ngr_anl1 = 2 or ngr_anl2 = 2 or ngr_anl3 = 2 or ngr_anl4 = 2  then
         nANL_SEL2 := 1;
      end if;
      if ngr_anl1 = 3 or ngr_anl2 = 3 or ngr_anl3 = 3 or ngr_anl4 = 3  then
         nANL_SEL3 := 1;
      end if;
      if ngr_anl1 = 4 or ngr_anl2 = 4 or ngr_anl3 = 4 or ngr_anl4 = 4  then
         nANL_SEL4 := 1;
      end if;


--     *************     
--     ***      
     delete from parus.yprepos02
     where authid = user;
     commit;

--     P_YPTURNIKCREATE(nIDENT, nSELECT, nPRINTSELECT);

     --   - 
        nDEL := 0;
        For rec1 in (select VT.*
                     from parus.valturns VT,
                          parus.dicaccs ac
                     where vt.account = ac.rn
                       and ac.acc_form = 100
                       and VT.Ident = nIDENT
                       and (nvl(nPRINTSELECT,0) = 0
                         or  exists (select null
                                     from selectlist Sl
                                     where Sl.ident = nSELECT
                                       and Sl.document = VT.RN)))
        loop
            --   
            begin
              select sum(S.ACNT_REMN_SUM), sum(S.ACNT_REMN_QUANT)
              into  nTSUM, nTQNT
              from parus.yprepos01 S
              where S.AUTHID    = user
               and S.ACCOUNT   = rec1.account
               and (nvl(S.ANALYTIC1,0) = nvl(rec1.analytic1,0) or nANL_SEL1 = 0)
               and (nvl(S.ANALYTIC2,0) = nvl(rec1.analytic2,0) or nANL_SEL2 = 0)
               and (nvl(S.ANALYTIC3,0) = nvl(rec1.analytic3,0) or nANL_SEL3 = 0)
               and (nvl(S.ANALYTIC4,0) = nvl(rec1.analytic4,0) or nANL_SEL4 = 0)
               and S.JUR_PERS  = rec1.JUR_PERS
               and S.Agent     = rec1.AGENT
               and S.NOMENCLATURE = rec1.NOMENCLATURE;
              exception
              when OTHERS then
                  nTSUM := 0;
                  nTQNT := 0;
            end;

            if (nvl(rec1.ACNT_REMN_SUM,0) <> nvl(nTSUM,0)) or (nvl(rec1.ACNT_REMN_QUANT,0)  <>  nvl(nTQNT,0)) then
               insert into YPREPOS02(AUTHID,ACCOUNT,ANALYTIC1,ANALYTIC2,ANALYTIC3,ANALYTIC4,AGENT,QMAT,SMAT,QOS,SOS,NOMENCLATOR,JURPERS,NOTE)
               values(user, rec1.account, rec1.analytic1,rec1.analytic2,rec1.analytic3,rec1.analytic4, rec1.agent, rec1.ACNT_REMN_QUANT, rec1.ACNT_REMN_SUM,
                      nTQNT, nTSUM, rec1.NOMENCLATURE, rec1.JUR_PERS,
                      '     ');
               commit;
               nDEL := 1;
            end if;

            --   
            begin
              select sum(S.ACNT_DEBIT_TURN_SUM), sum(S.ACNT_DEBIT_TURN_QUANT)
              into  nTSUM, nTQNT
              from parus.yprepos01 S
              where S.AUTHID    = user
               and S.ACCOUNT   = rec1.account
               and (nvl(S.ANALYTIC1,0) = nvl(rec1.analytic1,0) or nANL_SEL1 = 0)
               and (nvl(S.ANALYTIC2,0) = nvl(rec1.analytic2,0) or nANL_SEL2 = 0)
               and (nvl(S.ANALYTIC3,0) = nvl(rec1.analytic3,0) or nANL_SEL3 = 0)
               and (nvl(S.ANALYTIC4,0) = nvl(rec1.analytic4,0) or nANL_SEL4 = 0)
               and S.JUR_PERS  = rec1.JUR_PERS
               and S.Agent     = rec1.AGENT
               and S.NOMENCLATURE = rec1.NOMENCLATURE;
              exception
              when OTHERS then
                  nTSUM := 0;
                  nTQNT := 0;
            end;

            if (nvl(rec1.ACNT_DEBIT_TURN_SUM,0) <> nvl(nTSUM,0)) or (nvl(rec1.ACNT_DEBIT_TURN_QUANT,0)  <>  nvl(nTQNT,0)) then
               insert into YPREPOS02(AUTHID,ACCOUNT,ANALYTIC1,ANALYTIC2,ANALYTIC3,ANALYTIC4,AGENT,QMAT,SMAT,QOS,SOS,NOMENCLATOR,JURPERS,NOTE)
               values(user, rec1.account, rec1.analytic1,rec1.analytic2,rec1.analytic3,rec1.analytic4,
                      rec1.agent, rec1.ACNT_DEBIT_TURN_QUANT, rec1.ACNT_DEBIT_TURN_SUM,
                      nTQNT, nTSUM, rec1.NOMENCLATURE, rec1.JUR_PERS,
                      '   ');
               commit;
               nDEL := 1;
            end if;



            --   
            begin
              select sum(S.ACNT_CREDIT_TURN_SUM), sum(S.ACNT_CREDIT_TURN_QUANT)
              into  nTSUM, nTQNT
              from parus.yprepos01 S
              where S.AUTHID    = user
               and S.ACCOUNT   = rec1.account
               and (nvl(S.ANALYTIC1,0) = nvl(rec1.analytic1,0) or nANL_SEL1 = 0)
               and (nvl(S.ANALYTIC2,0) = nvl(rec1.analytic2,0) or nANL_SEL2 = 0)
               and (nvl(S.ANALYTIC3,0) = nvl(rec1.analytic3,0) or nANL_SEL3 = 0)
               and (nvl(S.ANALYTIC4,0) = nvl(rec1.analytic4,0) or nANL_SEL4 = 0)
               and S.JUR_PERS  = rec1.JUR_PERS
               and S.Agent     = rec1.AGENT
               and S.NOMENCLATURE = rec1.NOMENCLATURE;
              exception
              when OTHERS then
                  nTSUM := 0;
                  nTQNT := 0;
            end;

            if (nvl(rec1.ACNT_CREDIT_TURN_SUM,0) <> nvl(nTSUM,0)) or (nvl(rec1.ACNT_CREDIT_TURN_QUANT,0)  <>  nvl(nTQNT,0)) then
               insert into YPREPOS02(AUTHID,ACCOUNT,ANALYTIC1,ANALYTIC2,ANALYTIC3,ANALYTIC4, AGENT,
                                     QMAT,SMAT,QOS,SOS,NOMENCLATOR,JURPERS,NOTE)
               values(user, rec1.account, rec1.analytic1,  rec1.analytic2, rec1.analytic3, rec1.analytic4,
                      rec1.agent, rec1.ACNT_CREDIT_TURN_QUANT, rec1.ACNT_CREDIT_TURN_SUM,
                      nTQNT, nTSUM, rec1.NOMENCLATURE, rec1.JUR_PERS,
                      '   ');
               commit;
            end if;

            nDEL := 1;

        end loop;


        for rec2 in (select S.*
                     from parus.yprepos01 S
                     where S.AUTHID = user
                       and not exists(select null
                                      from parus.valturns VT
                                      where  VT.Ident = nIDENT
                                         and S.ACCOUNT   = VT.account
                                         and (nvl(S.ANALYTIC1,0) = nvl(VT.analytic1,0) or nANL_SEL1 = 0)
                                         and (nvl(S.ANALYTIC2,0) = nvl(VT.analytic2,0) or nANL_SEL2 = 0)
                                         and (nvl(S.ANALYTIC3,0) = nvl(VT.analytic3,0) or nANL_SEL3 = 0)
                                         and (nvl(S.ANALYTIC4,0) = nvl(VT.analytic4,0) or nANL_SEL4 = 0)
/*
                                         and nvl(S.ANALYTIC1,0) = nvl(VT.analytic1,0)
                                         and nvl(S.ANALYTIC2,0) = nvl(VT.analytic2,0)
                                         and nvl(S.ANALYTIC3,0) = nvl(VT.analytic3,0)
                                         and nvl(S.ANALYTIC4,0) = nvl(VT.analytic4,0)
  */

                                         and S.JUR_PERS         = VT.JUR_PERS
                                         and S.Agent            = VT.AGENT
                                         and S.NOMENCLATURE     = VT.NOMENCLATURE
                                         and VT.Ident = nIDENT
                                         and (nvl(nPRINTSELECT,0) = 0
                                              or  exists (select null
                                                          from selectlist Sl
                                                          where Sl.ident = nSELECT
                                                            and Sl.document = VT.RN))))
        loop
               insert into YPREPOS02(AUTHID,ACCOUNT,ANALYTIC1,ANALYTIC2,ANALYTIC3,ANALYTIC4,AGENT,QMAT,SMAT,QOS,SOS,NOMENCLATOR,JURPERS,NOTE)
               values(user, rec2.account, rec2.analytic1, rec2.analytic2, rec2.analytic3, rec2.analytic4,  rec2.agent, rec2.acnt_remn_quant, rec2.acnt_remn_sum,
                     0, 0, rec2.NOMENCLATURE, rec2.JUR_PERS,
                      '   '||trim(nvl(rec2.inum,''))||'    ');
               commit;
        end loop;

        if nCHECKACC = 1 then


        For rec1 in (select VT.Account, vt.date_from, vt.analytic1, vt.analytic2, vt.analytic3, vt.analytic4, vt.jur_pers, sum(vt.acnt_remn_sum) as sumi_rep
                     from parus.valturns VT
                     where VT.Ident = nIDENT
                     group by VT.Account, vt.date_from, vt.analytic1, vt.analytic2, vt.analytic3, vt.analytic4, vt.jur_pers)
        loop

            begin
              select sum(anl.acnt_debit_sum-anl.acnt_credit_sum)
              into nTSUM
              from accremns acc,
                   anlremns anl
              where acc.remn_date = rec1.date_from
                and acc.jur_pers = rec1.jur_pers
                and acc.account = rec1.account
                and acc.rn = anl.prn
                and (nvl(anl.ANALYTIC1,0) = nvl(rec1.analytic1,0) or nANL_SEL1 = 0)
                and (nvl(anl.ANALYTIC2,0) = nvl(rec1.analytic2,0) or nANL_SEL2 = 0)
                and (nvl(anl.ANALYTIC3,0) = nvl(rec1.analytic3,0) or nANL_SEL3 = 0)
                and (nvl(anl.ANALYTIC4,0) = nvl(rec1.analytic4,0) or nANL_SEL4 = 0);
/*
                and (anl.analytic1 = rec1.analytic1 or rec1.analytic1 is null)
                and (anl.analytic2 = rec1.analytic2 or rec1.analytic2 is null)
                and (anl.analytic3 = rec1.analytic3 or rec1.analytic3 is null)
                and (anl.analytic4 = rec1.analytic4 or rec1.analytic4 is null);
                */
              exception
              when OTHERS then
                 nTSUM := 0;
            end;

            if nvl(nTSUM,0) = 0 and rec1.sumi_rep <> 0 and rec1.analytic1 is null and rec1.analytic2 is null and rec1.analytic3 is null and rec1.analytic4 is null then
                  begin
                    select sum(acc.acnt_debit_sum-acc.acnt_credit_sum)
                    into nTSUM
                    from accremns acc
                    where acc.remn_date = rec1.date_from
                      and acc.jur_pers = rec1.jur_pers
                      and acc.account = rec1.account;
                    exception
                    when OTHERS then
                       nTSUM := 0;
                  end;
            end if;

            if nvl(nTSUM,0) <> nvl(rec1.sumi_rep,0) then

               insert into YPREPOS02(AUTHID,ACCOUNT,ANALYTIC1,ANALYTIC2,ANALYTIC3,ANALYTIC4,SMAT,SOS,JURPERS,NOTE)
               values(user, rec1.account, rec1.analytic1, rec1.analytic2, rec1.analytic3, rec1.analytic4, rec1.sumi_rep, nvl(nTSUM,0),
                     rec1.JUR_PERS, '        .');
               commit;

            end if;


        end loop;

        end if;

end;

/
grant execute on P_YPTURNIKERROR to public;

CREATE OR REPLACE PROCEDURE P_YPTURNIKCREATE_EXCEL( nIDENT  in number,
                                                    nSELECT in number,
                                                    nPRINTSELECT in number,
                                                    nTotalsOnly in number,
                                                    nCheckErrors in number,
                                                    sOUTAMGROUP  in varchar2,
                                                    dbgnIn       in date,
                                                    dEndIn       in date,
                                                    nAMORTBGN    in number,
                                                    nCHECKACC    in number)

as
  PAGE_REPORT        constant pkg_std.tSTRING := ' ';
  PAGE_ERRORS        constant pkg_std.tSTRING := '';

  LINE_HDR0          constant pkg_std.tSTRING := 'LINE_HDR0';

  LINE_HDR1          constant pkg_std.tSTRING := 'LINE_HDR1';

  LINE_HDR2          constant pkg_std.tSTRING := 'LINE_HDR2';

  LINE_HDR3          constant pkg_std.tSTRING := 'LINE_HDR3';
  CELL_PERIOD        constant pkg_std.tSTRING := 'CELL_PERIOD';

  LINE_HDR4          constant pkg_std.tSTRING := 'LINE_HDR4';
  LINE_HDR5          constant pkg_std.tSTRING := 'LINE_HDR5';
  LINE_HDR6          constant pkg_std.tSTRING := 'LINE_HDR6';
  LINE_HDR7          constant pkg_std.tSTRING := 'LINE_HDR7';

  LINE_ACCOUNT       constant pkg_std.tSTRING := 'LINE_ACCOUNT';
  CELL_ACCOUNT       constant pkg_std.tSTRING := 'CELL_ACCOUNT';
  CELL_NPP_A         constant pkg_std.tSTRING := 'CELL_NPP_A';

  LINE_ORG           constant pkg_std.tSTRING := 'LINE_ORG';
  CELL_ORG           constant pkg_std.tSTRING := 'CELL_ORG';
  CELL_NPP_O         constant pkg_std.tSTRING := 'CELL_NPP_O';

  LINE_MOL           constant pkg_std.tSTRING := 'LINE_MOL';
  CELL_MOL           constant pkg_std.tSTRING := 'CELL_MOL';
  CELL_NPP_M         constant pkg_std.tSTRING := 'CELL_NPP_M';

  LINE_DATA          constant pkg_std.tSTRING := 'LINE_DATA';
  CELL_NOMEN         constant pkg_std.tSTRING := 'CELL_NOMEN';
  CELL_INUM          constant pkg_std.tSTRING := 'CELL_INUM';
  CELL_QBE           constant pkg_std.tSTRING := 'CELL_QBE';
  CELL_SBE           constant pkg_std.tSTRING := 'CELL_SBE';
  CELL_QDE           constant pkg_std.tSTRING := 'CELL_QDE';
  CELL_SDE           constant pkg_std.tSTRING := 'CELL_SDE';
  CELL_QCR           constant pkg_std.tSTRING := 'CELL_QCR';
  CELL_SCR           constant pkg_std.tSTRING := 'CELL_SCR';
  CELL_QFIN          constant pkg_std.tSTRING := 'CELL_QFIN';
  CELL_SFIN          constant pkg_std.tSTRING := 'CELL_SFIN';
  CELL_AMORTA        constant pkg_std.tSTRING := 'CELL_AMORTA';
  CELL_AMORTP        constant pkg_std.tSTRING := 'CELL_AMORTP';
  CELL_OSTSUM        constant pkg_std.tSTRING := 'CELL_OSTSUM';
  CELL_NPP           constant pkg_std.tSTRING := 'CELL_NPP';
  nQBE    number(15, 3);
  nSBE    number(15, 2);
  nQDE    number(15, 3);
  nSDE    number(15, 2);
  nQCR    number(15, 3);
  nSCR    number(15, 2);
  nQFIN   number(15, 3);
  nSFIN   number(15, 2);
  nAMORTA number(15, 2);

  nAMORTP number(15, 2);
  nOSTSUM number(15, 2);

  LINE_MOL_TOTAL     constant pkg_std.tSTRING := 'LINE_MOL_TOTAL';
  CELL_MOLT          constant pkg_std.tSTRING := 'CELL_MOLT';
  CELL_QBE_M         constant pkg_std.tSTRING := 'CELL_QBE_M';
  CELL_SBE_M         constant pkg_std.tSTRING := 'CELL_SBE_M';
  CELL_QDE_M         constant pkg_std.tSTRING := 'CELL_QDE_M';
  CELL_SDE_M         constant pkg_std.tSTRING := 'CELL_SDE_M';
  CELL_QCR_M         constant pkg_std.tSTRING := 'CELL_QCR_M';
  CELL_SCR_M         constant pkg_std.tSTRING := 'CELL_SCR_M';
  CELL_QFIN_M        constant pkg_std.tSTRING := 'CELL_QFIN_M';
  CELL_SFIN_M        constant pkg_std.tSTRING := 'CELL_SFIN_M';
  CELL_AMORTA_M      constant pkg_std.tSTRING := 'CELL_AMORTA_M';
  CELL_AMORTP_M      constant pkg_std.tSTRING := 'CELL_AMORTP_M';
  CELL_OSTSUM_M      constant pkg_std.tSTRING := 'CELL_OSTSUM_M';
  CELL_NPP_MT        constant pkg_std.tSTRING := 'CELL_NPP_MT';
  nQBE_M    number(15, 3);
  nSBE_M    number(15, 2);
  nQDE_M    number(15, 3);
  nSDE_M    number(15, 2);
  nQCR_M    number(15, 3);
  nSCR_M    number(15, 2);
  nQFIN_M   number(15, 3);
  nSFIN_M   number(15, 2);
  nAMORTA_M number(15, 2);
  nAMORTP_M number(15, 2);

  nOSTSUM_M number(15, 2);

  LINE_ORG_TOTAL     constant pkg_std.tSTRING := 'LINE_ORG_TOTAL';
  CELL_ORGT          constant pkg_std.tSTRING := 'CELL_ORGT';
  CELL_QBE_O         constant pkg_std.tSTRING := 'CELL_QBE_O';
  CELL_SBE_O         constant pkg_std.tSTRING := 'CELL_SBE_O';
  CELL_QDE_O         constant pkg_std.tSTRING := 'CELL_QDE_O';
  CELL_SDE_O         constant pkg_std.tSTRING := 'CELL_SDE_O';
  CELL_QCR_O         constant pkg_std.tSTRING := 'CELL_QCR_O';
  CELL_SCR_O         constant pkg_std.tSTRING := 'CELL_SCR_O';
  CELL_QFIN_O        constant pkg_std.tSTRING := 'CELL_QFIN_O';
  CELL_SFIN_O        constant pkg_std.tSTRING := 'CELL_SFIN_O';
  CELL_AMORTA_O      constant pkg_std.tSTRING := 'CELL_AMORTA_O';
  CELL_AMORTP_O      constant pkg_std.tSTRING := 'CELL_AMORTP_O';
  CELL_OSTSUM_O      constant pkg_std.tSTRING := 'CELL_OSTSUM_O';
  CELL_NPP_OT        constant pkg_std.tSTRING := 'CELL_NPP_OT';
  nQBE_O    number(15, 3);
  nSBE_O    number(15, 2);
  nQDE_O    number(15, 3);
  nSDE_O    number(15, 2);
  nQCR_O    number(15, 3);
  nSCR_O    number(15, 2);
  nQFIN_O   number(15, 3);
  nSFIN_O   number(15, 2);
  nAMORTA_O number(15, 2);
  nAMORTP_O number(15, 2);

  nOSTSUM_O number(15, 2);

  LINE_ACCOUNT_TOTAL constant pkg_std.tSTRING := 'LINE_ACCOUNT_TOTAL';
  CELL_ACCOUNTT      constant pkg_std.tSTRING := 'CELL_ACCOUNTT';
  CELL_QBE_A         constant pkg_std.tSTRING := 'CELL_QBE_A';
  CELL_SBE_A         constant pkg_std.tSTRING := 'CELL_SBE_A';
  CELL_QDE_A         constant pkg_std.tSTRING := 'CELL_QDE_A';
  CELL_SDE_A         constant pkg_std.tSTRING := 'CELL_SDE_A';
  CELL_QCR_A         constant pkg_std.tSTRING := 'CELL_QCR_A';
  CELL_SCR_A         constant pkg_std.tSTRING := 'CELL_SCR_A';
  CELL_QFIN_A        constant pkg_std.tSTRING := 'CELL_QFIN_A';
  CELL_SFIN_A        constant pkg_std.tSTRING := 'CELL_SFIN_A';
  CELL_AMORTA_A      constant pkg_std.tSTRING := 'CELL_AMORTA_A';
  CELL_AMORTP_A      constant pkg_std.tSTRING := 'CELL_AMORTP_A';
  CELL_OSTSUM_A      constant pkg_std.tSTRING := 'CELL_OSTSUM_A';
  CELL_NPP_AT        constant pkg_std.tSTRING := 'CELL_NPP_AT';
  nQBE_A    number(15, 3);
  nSBE_A    number(15, 2);
  nQDE_A    number(15, 3);
  nSDE_A    number(15, 2);
  nQCR_A    number(15, 3);
  nSCR_A    number(15, 2);
  nQFIN_A   number(15, 3);
  nSFIN_A   number(15, 2);
  nAMORTA_A number(15, 2);
  nAMORTP_A number(15, 2);
  nOSTSUM_A number(15, 2);

  LINE_TOTAL         constant pkg_std.tSTRING := 'LINE_TOTAL';
  CELL_QBE_T         constant pkg_std.tSTRING := 'CELL_QBE_T';
  CELL_SBE_T         constant pkg_std.tSTRING := 'CELL_SBE_T';
  CELL_QDE_T         constant pkg_std.tSTRING := 'CELL_QDE_T';
  CELL_SDE_T         constant pkg_std.tSTRING := 'CELL_SDE_T';
  CELL_QCR_T         constant pkg_std.tSTRING := 'CELL_QCR_T';
  CELL_SCR_T         constant pkg_std.tSTRING := 'CELL_SCR_T';
  CELL_QFIN_T        constant pkg_std.tSTRING := 'CELL_QFIN_T';
  CELL_SFIN_T        constant pkg_std.tSTRING := 'CELL_SFIN_T';
  CELL_AMORTA_T      constant pkg_std.tSTRING := 'CELL_AMORTA_T';
  CELL_AMORTP_T      constant pkg_std.tSTRING := 'CELL_AMORTP_T';
  CELL_OSTSUM_T      constant pkg_std.tSTRING := 'CELL_OSTSUM_T';
  nQBE_T    number(15, 3);
  nSBE_T    number(15, 2);
  nQDE_T    number(15, 3);
  nSDE_T    number(15, 2);
  nQCR_T    number(15, 3);
  nSCR_T    number(15, 2);
  nQFIN_T   number(15, 3);
  nSFIN_T   number(15, 2);
  nAMORTA_T number(15, 2);
  nAMORTP_T number(15, 2);
  nOSTSUM_T number(15, 2);

  LINE_DELIMITER     constant pkg_std.tSTRING := 'LINE_DELIMITER';

  --  
  LINE_HDRE0          constant pkg_std.tSTRING := 'LINE_HDRE0';

  LINE_HDRE1          constant pkg_std.tSTRING := 'LINE_HDRE1';

  LINE_HDRE2          constant pkg_std.tSTRING := 'LINE_HDRE2';

  LINE_HDRE3          constant pkg_std.tSTRING := 'LINE_HDRE3';
  CELL_PERIODE        constant pkg_std.tSTRING := 'CELL_PERIODE';

  LINE_HDRE4          constant pkg_std.tSTRING := 'LINE_HDRE4';

  LINE_ACCOUNTE       constant pkg_std.tSTRING := 'LINE_ACCOUNTE';
  CELL_ACCOUNTE       constant pkg_std.tSTRING := 'CELL_ACCOUNTE';
  CELL_NPP_AE         constant pkg_std.tSTRING := 'CELL_NPP_AE';

  LINE_ORGE           constant pkg_std.tSTRING := 'LINE_ORGE';
  CELL_ORGE           constant pkg_std.tSTRING := 'CELL_ORGE';
  CELL_NPP_OE         constant pkg_std.tSTRING := 'CELL_NPP_OE';

  LINE_MOLE           constant pkg_std.tSTRING := 'LINE_MOLE';
  CELL_MOLE           constant pkg_std.tSTRING := 'CELL_MOLE';
  CELL_NPP_ME         constant pkg_std.tSTRING := 'CELL_NPP_ME';

  LINE_DATAE          constant pkg_std.tSTRING := 'LINE_DATAE';
  CELL_NOMENE         constant pkg_std.tSTRING := 'CELL_NOMENE';
  CELL_QMAT           constant pkg_std.tSTRING := 'CELL_QMAT';
  CELL_SMAT           constant pkg_std.tSTRING := 'CELL_SMAT';
  CELL_QOS            constant pkg_std.tSTRING := 'CELL_QOS';
  CELL_SOS            constant pkg_std.tSTRING := 'CELL_SOS';
  CELL_QSUB           constant pkg_std.tSTRING := 'CELL_QSUB';
  CELL_SSUB           constant pkg_std.tSTRING := 'CELL_SSUB';
  CELL_NPPE           constant pkg_std.tSTRING := 'CELL_NPPE';
  nQMAT   number(15, 3);
  nSMAT   number(15, 2);
  nQOS    number(15, 3);
  nSOS    number(15, 2);
  nQSUB   number(15, 3);
  nSSUB   number(15, 2);

  LINE_DELIMITERE     constant pkg_std.tSTRING := 'LINE_DELIMITERE';

  iIdx      integer;
  iNpp      integer;
  dDateF    date;
  dDateT    date;
  nAccount   integer;
  nAnalytic1 integer;
  sAccount  varchar2(240);
  nJurPers  integer;
  sJurPers  varchar2(240);
  nAgent    integer;
  sAgent    varchar2(240);



  bDrawNPP     constant boolean := false;

  appAfterData constant integer := 1;
  appAfterMOL  constant integer := 2;
  appMode      integer default 0;

  procedure DrawHDR( Date_From in date, Date_To in Date )
  as
  begin
    iIdx := prsg_excel.LINE_APPEND( LINE_HDR0 );
    iIdx := prsg_excel.LINE_APPEND( LINE_HDR1, LINE_HDR0 );
    iIdx := prsg_excel.LINE_APPEND( LINE_HDR2, LINE_HDR1 );
    iIdx := prsg_excel.LINE_APPEND( LINE_HDR3, LINE_HDR2 );
    prsg_excel.CELL_VALUE_WRITE( CELL_PERIOD, 0, iIdx, '  ' || To_Char( Date_From, 'DD.MM.YYYY' ) ||
                                                       '  ' || To_Char( Date_To, 'DD.MM.YYYY' ) );
    iIdx := prsg_excel.LINE_APPEND( LINE_HDR4, LINE_HDR3 );
    iIdx := prsg_excel.LINE_APPEND( LINE_HDR5, LINE_HDR4 );
    iIdx := prsg_excel.LINE_APPEND( LINE_HDR6, LINE_HDR5 );
    iIdx := prsg_excel.LINE_APPEND( LINE_HDR7, LINE_HDR6 );
    iIdx := prsg_excel.LINE_APPEND( LINE_DELIMITER, LINE_HDR7 );
  end;
  procedure DrawAccount( AccNumber in varchar2 )
  as
  begin
    iIdx := prsg_excel.LINE_APPEND( LINE_ACCOUNT, LINE_DELIMITER );
    if bDrawNpp then
      pkg_util.Inc( iNpp );
      prsg_excel.CELL_VALUE_WRITE( CELL_NPP_A, 0, iIdx, iNpp );
    end if;
    prsg_excel.CELL_VALUE_WRITE( CELL_ACCOUNT, 0, iIdx, AccNumber );
    iIdx := prsg_excel.LINE_APPEND( LINE_DELIMITER, LINE_ACCOUNT );
  end;
  procedure DrawOrg( OrgName in varchar2 )
  as
  begin
    iIdx := prsg_excel.LINE_APPEND( LINE_ORG, LINE_DELIMITER );
    if bDrawNpp then
      pkg_util.Inc( iNpp );
      prsg_excel.CELL_VALUE_WRITE( CELL_NPP_O, 0, iIdx, iNpp );
    end if;
    prsg_excel.CELL_VALUE_WRITE( CELL_ORG, 0, iIdx, OrgName );
    iIdx := prsg_excel.LINE_APPEND( LINE_DELIMITER, LINE_ORG );
  end;
  procedure DrawMOL( MolName in varchar2 )
  as
  begin
    iIdx := prsg_excel.LINE_APPEND( LINE_MOL, LINE_DELIMITER );
    if bDrawNpp then
      pkg_util.Inc( iNpp );
      prsg_excel.CELL_VALUE_WRITE( CELL_NPP_M, 0, iIdx, iNpp );
    end if;
    prsg_excel.CELL_VALUE_WRITE( CELL_MOL, 0, iIdx, MolName );
    iIdx := prsg_excel.LINE_APPEND( LINE_DELIMITER, LINE_MOL );
  end;
  procedure DrawAccountT( AccNumber in varchar2 )
  as
  begin
    iIdx := prsg_excel.LINE_APPEND( LINE_ACCOUNT_TOTAL, LINE_DELIMITER );
    if bDrawNpp then
      pkg_util.Inc( iNpp );
      prsg_excel.CELL_VALUE_WRITE( CELL_NPP_AT, 0, iIdx, iNpp );
    end if;
    prsg_excel.CELL_VALUE_WRITE( CELL_ACCOUNTT, 0, iIdx, AccNumber );
    prsg_excel.CELL_VALUE_WRITE( CELL_QBE_A, 0, iIdx, nQBE_A );
    prsg_excel.CELL_VALUE_WRITE( CELL_SBE_A, 0, iIdx, nSBE_A );
    prsg_excel.CELL_VALUE_WRITE( CELL_QDE_A, 0, iIdx, nQDE_A );
    prsg_excel.CELL_VALUE_WRITE( CELL_SDE_A, 0, iIdx, nSDE_A );
    prsg_excel.CELL_VALUE_WRITE( CELL_QCR_A, 0, iIdx, nQCR_A );
    prsg_excel.CELL_VALUE_WRITE( CELL_SCR_A, 0, iIdx, nSCR_A );
    prsg_excel.CELL_VALUE_WRITE( CELL_QFIN_A, 0, iIdx, nQFIN_A );
    prsg_excel.CELL_VALUE_WRITE( CELL_SFIN_A, 0, iIdx, nSFIN_A );
    prsg_excel.CELL_VALUE_WRITE( CELL_AMORTA_A, 0, iIdx, nAMORTA_A );
    prsg_excel.CELL_VALUE_WRITE( CELL_AMORTP_A, 0, iIdx, nAMORTP_A );

    prsg_excel.CELL_VALUE_WRITE( CELL_OSTSUM_A, 0, iIdx, nOSTSUM_A );
    iIdx := prsg_excel.LINE_APPEND( LINE_DELIMITER, LINE_ACCOUNT_TOTAL );
  end;
  procedure DrawOrgT( OrgName in varchar2 )
  as
  begin
    iIdx := prsg_excel.LINE_APPEND( LINE_ORG_TOTAL, LINE_DELIMITER );
    if bDrawNpp then
      pkg_util.Inc( iNpp );
      prsg_excel.CELL_VALUE_WRITE( CELL_NPP_OT, 0, iIdx, iNpp );
    end if;
    prsg_excel.CELL_VALUE_WRITE( CELL_ORGT, 0, iIdx, OrgName );
    prsg_excel.CELL_VALUE_WRITE( CELL_QBE_O, 0, iIdx, nQBE_O );
    prsg_excel.CELL_VALUE_WRITE( CELL_SBE_O, 0, iIdx, nSBE_O );
    prsg_excel.CELL_VALUE_WRITE( CELL_QDE_O, 0, iIdx, nQDE_O );
    prsg_excel.CELL_VALUE_WRITE( CELL_SDE_O, 0, iIdx, nSDE_O );
    prsg_excel.CELL_VALUE_WRITE( CELL_QCR_O, 0, iIdx, nQCR_O );
    prsg_excel.CELL_VALUE_WRITE( CELL_SCR_O, 0, iIdx, nSCR_O );
    prsg_excel.CELL_VALUE_WRITE( CELL_QFIN_O, 0, iIdx, nQFIN_O );
    prsg_excel.CELL_VALUE_WRITE( CELL_SFIN_O, 0, iIdx, nSFIN_O );
    prsg_excel.CELL_VALUE_WRITE( CELL_AMORTA_O, 0, iIdx, nAMORTA_O );
    prsg_excel.CELL_VALUE_WRITE( CELL_AMORTP_O, 0, iIdx, nAMORTP_O );
    prsg_excel.CELL_VALUE_WRITE( CELL_OSTSUM_O, 0, iIdx, nOSTSUM_O );
    iIdx := prsg_excel.LINE_APPEND( LINE_DELIMITER, LINE_ORG_TOTAL );
  end;
  procedure DrawMOLT( MolName in varchar2 )
  as
  begin
    if nTotalsOnly = 1 then
      iIdx := prsg_excel.LINE_APPEND( LINE_MOL_TOTAL, LINE_DELIMITER );
    else
      iIdx := prsg_excel.LINE_APPEND( LINE_MOL_TOTAL, LINE_DATA );
    end if;
    if bDrawNpp then
      pkg_util.Inc( iNpp );
      prsg_excel.CELL_VALUE_WRITE( CELL_NPP_MT, 0, iIdx, iNpp );
    end if;
    prsg_excel.CELL_VALUE_WRITE( CELL_MOLT, 0, iIdx, MolName );
    prsg_excel.CELL_VALUE_WRITE( CELL_QBE_M, 0, iIdx, nQBE_M );
    prsg_excel.CELL_VALUE_WRITE( CELL_SBE_M, 0, iIdx, nSBE_M );
    prsg_excel.CELL_VALUE_WRITE( CELL_QDE_M, 0, iIdx, nQDE_M );
    prsg_excel.CELL_VALUE_WRITE( CELL_SDE_M, 0, iIdx, nSDE_M );
    prsg_excel.CELL_VALUE_WRITE( CELL_QCR_M, 0, iIdx, nQCR_M );
    prsg_excel.CELL_VALUE_WRITE( CELL_SCR_M, 0, iIdx, nSCR_M );
    prsg_excel.CELL_VALUE_WRITE( CELL_QFIN_M, 0, iIdx, nQFIN_M );
    prsg_excel.CELL_VALUE_WRITE( CELL_SFIN_M, 0, iIdx, nSFIN_M );
    prsg_excel.CELL_VALUE_WRITE( CELL_AMORTA_M, 0, iIdx, nAMORTA_M );
    prsg_excel.CELL_VALUE_WRITE( CELL_AMORTP_M, 0, iIdx, nAMORTP_M );

    prsg_excel.CELL_VALUE_WRITE( CELL_OSTSUM_M, 0, iIdx, nOSTSUM_M );
    iIdx := prsg_excel.LINE_APPEND( LINE_DELIMITER, LINE_MOL_TOTAL );
  end;
  procedure DrawTotal
  as
  begin
    iIdx := prsg_excel.LINE_APPEND( LINE_TOTAL, LINE_DELIMITER );
    prsg_excel.CELL_VALUE_WRITE( CELL_QBE_T, 0, iIdx, nQBE_T );
    prsg_excel.CELL_VALUE_WRITE( CELL_SBE_T, 0, iIdx, nSBE_T );
    prsg_excel.CELL_VALUE_WRITE( CELL_QDE_T, 0, iIdx, nQDE_T );
    prsg_excel.CELL_VALUE_WRITE( CELL_SDE_T, 0, iIdx, nSDE_T );
    prsg_excel.CELL_VALUE_WRITE( CELL_QCR_T, 0, iIdx, nQCR_T );
    prsg_excel.CELL_VALUE_WRITE( CELL_SCR_T, 0, iIdx, nSCR_T );
    prsg_excel.CELL_VALUE_WRITE( CELL_QFIN_T, 0, iIdx, nQFIN_T );
    prsg_excel.CELL_VALUE_WRITE( CELL_SFIN_T, 0, iIdx, nSFIN_T );
    prsg_excel.CELL_VALUE_WRITE( CELL_AMORTA_T, 0, iIdx, nAMORTA_T );
    prsg_excel.CELL_VALUE_WRITE( CELL_AMORTP_T, 0, iIdx, nAMORTP_T );

    prsg_excel.CELL_VALUE_WRITE( CELL_OSTSUM_T, 0, iIdx, nOSTSUM_T );
  end;
  procedure DrawData( sNomen in varchar2, sInvNumb in varchar2 )
  as
  begin
    if appMode = appAfterMOL then
      iIdx := prsg_excel.LINE_APPEND( LINE_DATA, LINE_MOL );
    elsif appMode = appAfterData then
      iIdx := prsg_excel.LINE_CONTINUE( LINE_DATA );
    end if;
    if bDrawNpp then
      pkg_util.Inc( iNpp );
      prsg_excel.CELL_VALUE_WRITE( CELL_NPP, 0, iIdx, iNpp );
    end if;
    prsg_excel.CELL_VALUE_WRITE( CELL_NOMEN, 0, iIdx, sNomen );
    prsg_excel.CELL_VALUE_WRITE( CELL_INUM, 0, iIdx, sInvNumb );
    prsg_excel.CELL_VALUE_WRITE( CELL_QBE, 0, iIdx, nQBE );
    prsg_excel.CELL_VALUE_WRITE( CELL_SBE, 0, iIdx, nSBE );
    prsg_excel.CELL_VALUE_WRITE( CELL_QDE, 0, iIdx, nQDE );
    prsg_excel.CELL_VALUE_WRITE( CELL_SDE, 0, iIdx, nSDE );
    prsg_excel.CELL_VALUE_WRITE( CELL_QCR, 0, iIdx, nQCR );
    prsg_excel.CELL_VALUE_WRITE( CELL_SCR, 0, iIdx, nSCR );
    prsg_excel.CELL_VALUE_WRITE( CELL_QFIN, 0, iIdx, nQFIN );
    prsg_excel.CELL_VALUE_WRITE( CELL_SFIN, 0, iIdx, nSFIN );
    prsg_excel.CELL_VALUE_WRITE( CELL_AMORTA, 0, iIdx, nAMORTA );
    prsg_excel.CELL_VALUE_WRITE( CELL_AMORTP, 0, iIdx, nAMORTP );

    prsg_excel.CELL_VALUE_WRITE( CELL_OSTSUM, 0, iIdx, nOSTSUM );
    appMode := appAfterData;
  end;
  procedure DeleteRowsTemplates
  as
  begin
     prsg_excel.LINE_DELETE(LINE_HDR0);
    prsg_excel.LINE_DELETE(LINE_HDR1);
    prsg_excel.LINE_DELETE(LINE_HDR2);
    prsg_excel.LINE_DELETE(LINE_HDR3);
    prsg_excel.LINE_DELETE(LINE_HDR4);
    prsg_excel.LINE_DELETE(LINE_HDR5);
    prsg_excel.LINE_DELETE(LINE_HDR6);
    prsg_excel.LINE_DELETE(LINE_HDR7);
    prsg_excel.LINE_DELETE(LINE_ACCOUNT);
    prsg_excel.LINE_DELETE(LINE_ORG);
    prsg_excel.LINE_DELETE(LINE_MOL);
    prsg_excel.LINE_DELETE(LINE_DATA);
    prsg_excel.LINE_DELETE(LINE_MOL_TOTAL);
    prsg_excel.LINE_DELETE(LINE_ORG_TOTAL);
    prsg_excel.LINE_DELETE(LINE_ACCOUNT_TOTAL);
    prsg_excel.LINE_DELETE(LINE_TOTAL);
    prsg_excel.LINE_DELETE(LINE_DELIMITER);
  end;
  procedure InitRowsAndCellsTemplates
  as
  begin
    prsg_excel.LINE_DESCRIBE( LINE_HDR0 );
    prsg_excel.LINE_DESCRIBE( LINE_HDR1 );
    prsg_excel.LINE_DESCRIBE( LINE_HDR2 );
    prsg_excel.LINE_DESCRIBE( LINE_HDR3 );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_HDR3, CELL_PERIOD );

    prsg_excel.LINE_DESCRIBE( LINE_HDR4 );
    prsg_excel.LINE_DESCRIBE( LINE_HDR5 );
    prsg_excel.LINE_DESCRIBE( LINE_HDR6 );
    prsg_excel.LINE_DESCRIBE( LINE_HDR7 );

    prsg_excel.LINE_DESCRIBE( LINE_ACCOUNT );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT, CELL_ACCOUNT );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT, CELL_NPP_A );
    prsg_excel.LINE_DESCRIBE( LINE_ORG );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG, CELL_ORG );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG, CELL_NPP_O );

    prsg_excel.LINE_DESCRIBE( LINE_MOL );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL, CELL_MOL );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL, CELL_NPP_M );

    prsg_excel.LINE_DESCRIBE( LINE_DATA );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_NOMEN );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_INUM );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_QBE );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_SBE );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_QDE );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_SDE );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_QCR );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_SCR );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_QFIN );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_SFIN );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_AMORTA );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_AMORTP );

    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_OSTSUM );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_NPP );

    prsg_excel.LINE_DESCRIBE( LINE_MOL_TOTAL );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_MOLT );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_QBE_M );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_SBE_M );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_QDE_M );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_SDE_M );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_QCR_M );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_SCR_M );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_QFIN_M );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_SFIN_M );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_AMORTA_M );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_AMORTP_M );

    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_OSTSUM_M );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOL_TOTAL, CELL_NPP_MT );

    prsg_excel.LINE_DESCRIBE( LINE_ORG_TOTAL );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_ORGT );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_QBE_O );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_SBE_O );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_QDE_O );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_SDE_O );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_QCR_O );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_SCR_O );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_QFIN_O );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_SFIN_O );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_AMORTA_O );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_AMORTP_O );

    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_OSTSUM_O );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORG_TOTAL, CELL_NPP_OT );

   prsg_excel.LINE_DESCRIBE( LINE_ACCOUNT_TOTAL );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_ACCOUNTT );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_QBE_A );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_SBE_A );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_QDE_A );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_SDE_A );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_QCR_A );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_SCR_A );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_QFIN_A );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_SFIN_A );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_AMORTA_A );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_AMORTP_A );

    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_OSTSUM_A );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNT_TOTAL, CELL_NPP_AT );

    prsg_excel.LINE_DESCRIBE( LINE_TOTAL );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_TOTAL, CELL_QBE_T );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_TOTAL, CELL_SBE_T );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_TOTAL, CELL_QDE_T );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_TOTAL, CELL_SDE_T );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_TOTAL, CELL_QCR_T );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_TOTAL, CELL_SCR_T );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_TOTAL, CELL_QFIN_T );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_TOTAL, CELL_SFIN_T );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_TOTAL, CELL_AMORTA_T );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_TOTAL, CELL_AMORTP_T );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_TOTAL, CELL_OSTSUM_T );

    prsg_excel.LINE_DESCRIBE( LINE_DELIMITER );

  end;
  procedure ResetVarA
  as
  begin
    nQBE_A := 0; nSBE_A := 0; nQDE_A := 0; nSDE_A := 0; nQCR_A := 0; nSCR_A := 0; nQFIN_A := 0; nSFIN_A := 0; nAMORTA_A := 0;  nAMORTP_A := 0; nOSTSUM_A := 0;
  end;
  procedure ResetVarO
  as
  begin
    nQBE_O := 0; nSBE_O := 0; nQDE_O := 0; nSDE_O := 0; nQCR_O := 0; nSCR_O := 0; nQFIN_O := 0; nSFIN_O := 0; nAMORTA_O := 0; nAMORTP_O := 0; nOSTSUM_O := 0;
  end;
  procedure ResetVarM
  as
  begin
    nQBE_M := 0; nSBE_M := 0; nQDE_M := 0; nSDE_M := 0; nQCR_M := 0; nSCR_M := 0; nQFIN_M := 0; nSFIN_M := 0; nAMORTA_M := 0; nAMORTP_M := 0; nOSTSUM_M := 0;
  end;
  procedure ResetVarT
  as
  begin
    nQBE_T := 0; nSBE_T := 0; nQDE_T := 0; nSDE_T := 0; nQCR_T := 0; nSCR_T := 0; nQFIN_T := 0; nSFIN_T := 0; nAMORTA_T := 0; nAMORTP_T := 0; nOSTSUM_T := 0;
  end;
  procedure SumTotals
  as
  begin
    pkg_util.Inc( nQBE_T, nQBE_A );
    pkg_util.Inc( nSBE_T, nSBE_A );
    pkg_util.Inc( nQDE_T, nQDE_A );
    pkg_util.Inc( nSDE_T, nSDE_A );
    pkg_util.Inc( nQCR_T, nQCR_A );
    pkg_util.Inc( nSCR_T, nSCR_A );
    pkg_util.Inc( nQFIN_T, nQFIN_A );
    pkg_util.Inc( nSFIN_T, nSFIN_A );
    pkg_util.Inc( nAMORTA_T, nAMORTA_A );
    pkg_util.Inc( nAMORTP_T, nAMORTP_A );
    pkg_util.Inc( nOSTSUM_T, nOSTSUM_A );
  end;
  procedure SumAccount
  as
  begin
    pkg_util.Inc( nQBE_A, nQBE_O );
    pkg_util.Inc( nSBE_A, nSBE_O );
    pkg_util.Inc( nQDE_A, nQDE_O );
    pkg_util.Inc( nSDE_A, nSDE_O );
    pkg_util.Inc( nQCR_A, nQCR_O );
    pkg_util.Inc( nSCR_A, nSCR_O );
    pkg_util.Inc( nQFIN_A, nQFIN_O );
    pkg_util.Inc( nSFIN_A, nSFIN_O );
    pkg_util.Inc( nAMORTA_A, nAMORTA_O );
    pkg_util.Inc( nAMORTP_A, nAMORTP_O );
    pkg_util.Inc( nOSTSUM_A, nOSTSUM_O );
  end;
  procedure SumOrg
  as
  begin
    pkg_util.Inc( nQBE_O, nQBE_M );
    pkg_util.Inc( nSBE_O, nSBE_M );
    pkg_util.Inc( nQDE_O, nQDE_M );
    pkg_util.Inc( nSDE_O, nSDE_M );
    pkg_util.Inc( nQCR_O, nQCR_M );
    pkg_util.Inc( nSCR_O, nSCR_M );
    pkg_util.Inc( nQFIN_O, nQFIN_M );
    pkg_util.Inc( nSFIN_O, nSFIN_M );
    pkg_util.Inc( nAMORTA_O, nAMORTA_M );
    pkg_util.Inc( nAMORTP_O, nAMORTP_M );
    pkg_util.Inc( nOSTSUM_O, nOSTSUM_M );
  end;
  procedure SumMOL
  as
  begin
    pkg_util.Inc( nQBE_M, nQBE );
    pkg_util.Inc( nSBE_M, nSBE );
    pkg_util.Inc( nQDE_M, nQDE );
    pkg_util.Inc( nSDE_M, nSDE );
    pkg_util.Inc( nQCR_M, nQCR );
    pkg_util.Inc( nSCR_M, nSCR );
    pkg_util.Inc( nQFIN_M, nQFIN );
    pkg_util.Inc( nSFIN_M, nSFIN );
    pkg_util.Inc( nAMORTA_M, nAMORTA );
    pkg_util.Inc( nAMORTP_M, nAMORTP );
    pkg_util.Inc( nOSTSUM_M, nOSTSUM );
  end;

  procedure InitERowsAndCellsTemplates
  as
  begin
    prsg_excel.LINE_DESCRIBE( LINE_HDRE0 );
    prsg_excel.LINE_DESCRIBE( LINE_HDRE1 );
    prsg_excel.LINE_DESCRIBE( LINE_HDRE2 );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_HDRE2, CELL_PERIODE );
    prsg_excel.LINE_DESCRIBE( LINE_HDRE3 );

    prsg_excel.LINE_DESCRIBE( LINE_HDRE4 );

    prsg_excel.LINE_DESCRIBE( LINE_ACCOUNTE );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNTE, CELL_ACCOUNTE);
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ACCOUNTE, CELL_NPP_AE );

    prsg_excel.LINE_DESCRIBE( LINE_ORGE );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORGE, CELL_ORGE );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_ORGE, CELL_NPP_OE );

    prsg_excel.LINE_DESCRIBE( LINE_MOLE );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOLE, CELL_MOLE );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_MOLE, CELL_NPP_ME );

    prsg_excel.LINE_DESCRIBE( LINE_DATAE );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATAE, CELL_NOMENE );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATAE, CELL_QMAT );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATAE, CELL_SMAT );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATAE, CELL_QOS );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATAE, CELL_SOS );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATAE, CELL_QSUB );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATAE, CELL_SSUB );
    prsg_excel.LINE_CELL_DESCRIBE( LINE_DATA, CELL_NPPE );

    prsg_excel.LINE_DESCRIBE( LINE_DELIMITERE );
  end;
  procedure DrawHDRE( Date_From in date, Date_To in Date )
  as
  begin
    iIdx := prsg_excel.LINE_APPEND( LINE_HDRE0 );
    iIdx := prsg_excel.LINE_APPEND( LINE_HDRE1, LINE_HDRE0 );
    iIdx := prsg_excel.LINE_APPEND( LINE_HDRE2, LINE_HDRE1 );
    prsg_excel.CELL_VALUE_WRITE( CELL_PERIODE, 0, iIdx, '  ' || To_Char( Date_From, 'DD.MM.YYYY' ) ||
                                                        '  ' || To_Char( Date_To, 'DD.MM.YYYY' ) );
    iIdx := prsg_excel.LINE_APPEND( LINE_HDRE3, LINE_HDRE2 );
    iIdx := prsg_excel.LINE_APPEND( LINE_HDRE4, LINE_HDRE3 );
    iIdx := prsg_excel.LINE_APPEND( LINE_DELIMITERE, LINE_HDRE4 );
  end;
  procedure DrawAccountE( AccNumber in varchar2 )
  as
  begin
    iIdx := prsg_excel.LINE_APPEND( LINE_ACCOUNTE, LINE_DELIMITERE );
    if bDrawNpp then
      pkg_util.Inc( iNpp );
      prsg_excel.CELL_VALUE_WRITE( CELL_NPP_AE, 0, iIdx, iNpp );
    end if;
    prsg_excel.CELL_VALUE_WRITE( CELL_ACCOUNTE, 0, iIdx, AccNumber );
    iIdx := prsg_excel.LINE_APPEND( LINE_DELIMITERE, LINE_ACCOUNTE );
  end;
  procedure DrawOrgE( OrgName in varchar2 )
  as
  begin
    iIdx := prsg_excel.LINE_APPEND( LINE_ORGE, LINE_DELIMITERE );
    if bDrawNpp then
      pkg_util.Inc( iNpp );
      prsg_excel.CELL_VALUE_WRITE( CELL_NPP_OE, 0, iIdx, iNpp );
    end if;
    prsg_excel.CELL_VALUE_WRITE( CELL_ORGE, 0, iIdx, OrgName );
    iIdx := prsg_excel.LINE_APPEND( LINE_DELIMITERE, LINE_ORGE );
  end;
  procedure DrawMOLE( MolName in varchar2 )
  as
  begin
    iIdx := prsg_excel.LINE_APPEND( LINE_MOLE, LINE_DELIMITERE );
    if bDrawNpp then
      pkg_util.Inc( iNpp );
      prsg_excel.CELL_VALUE_WRITE( CELL_NPP_ME, 0, iIdx, iNpp );
    end if;
    prsg_excel.CELL_VALUE_WRITE( CELL_MOLE, 0, iIdx, MolName );
    iIdx := prsg_excel.LINE_APPEND( LINE_DELIMITERE, LINE_MOLE );
  end;
  procedure DrawDataE( sNomen in varchar2, sNote in varchar2 )
  as
  begin
    if appMode = appAfterMOL then
      iIdx := prsg_excel.LINE_APPEND( LINE_DATAE, LINE_MOLE );
    elsif appMode = appAfterData then
      iIdx := prsg_excel.LINE_CONTINUE( LINE_DATAE );
    end if;
    if bDrawNpp then
      pkg_util.Inc( iNpp );
      prsg_excel.CELL_VALUE_WRITE( CELL_NPPE, 0, iIdx, iNpp );
    end if;
    prsg_excel.CELL_VALUE_WRITE( CELL_NOMENE, 0, iIdx, sNomen|| ': '|| sNote );
    prsg_excel.CELL_VALUE_WRITE( CELL_QMAT, 0, iIdx, nQMAT );
    prsg_excel.CELL_VALUE_WRITE( CELL_SMAT, 0, iIdx, nSMAT );
    prsg_excel.CELL_VALUE_WRITE( CELL_QOS, 0, iIdx, nQOS );
    prsg_excel.CELL_VALUE_WRITE( CELL_SOS, 0, iIdx, nSOS );
    prsg_excel.CELL_VALUE_WRITE( CELL_QSUB, 0, iIdx, nQSUB );
    prsg_excel.CELL_VALUE_WRITE( CELL_SSUB, 0, iIdx, nSSUB );
    appMode := appAfterData;
  end;
  procedure DeleteERowsTemplates
  as
  begin
    prsg_excel.LINE_DELETE(LINE_HDRE0);
    prsg_excel.LINE_DELETE(LINE_HDRE1);
    prsg_excel.LINE_DELETE(LINE_HDRE2);
    prsg_excel.LINE_DELETE(LINE_HDRE3);
    prsg_excel.LINE_DELETE(LINE_HDRE4);
    prsg_excel.LINE_DELETE(LINE_ACCOUNTE);
    prsg_excel.LINE_DELETE(LINE_ORGE);
    prsg_excel.LINE_DELETE(LINE_MOLE);
    prsg_excel.LINE_DELETE(LINE_DATAE);
    prsg_excel.LINE_DELETE(LINE_DELIMITERE);
  end;

begin


--  p_exception(0,'   ');
  --   
  p_ypturnikcreate( nIDENT, nSELECT, nPRINTSELECT, null, null, nAMORTBGN );

  if dbgnIn is not null and dEndIn is not null then
    if dbgnIn <= dEndIn then
      delete
        from yprepos01 t
       where t.authid = utilizer
         and exists (select null
                       from v_inventory i
                      where i.nrn = t.rn
                        and not (i.din_date between dbgnIn and dEndIn) );
      commit;
    else p_exception(0,'            ');
    end if;
  end if;

  if sOUTAMGROUP is not null then
     delete from yprepos01 r
     where r.authid = user
       and exists(select null
                  from inventory i,
                       INVTAXGR g
                  where i.rn = r.rn
                    and i.TAX_GROUP = g.numb
                    and instr(';'||trim(sOUTAMGROUP)||';', ';'||trim(g.code)||';') > 0);
  end if;



--  commit;


  -- ,   
  begin
    select min( date_from ), max(date_to)
    into dDateF, dDateT
    from parus.yprepos01 T
    where T.Authid = user;
    exception
    when OTHERS then
         P_EXCEPTION(0, '  !');
  end;

  prsg_excel.PREPARE;

  --   
  prsg_excel.SHEET_SELECT( PAGE_REPORT );

  InitRowsAndCellsTemplates;

  DrawHDR( dDateF, dDateT );
  iNpp := 0;

  nAccount := 0; nAnalytic1 := 0;
  ResetVarT;

  for recA in ( select distinct d.account, d.analytic1,d.analytic2,d.analytic3,d.analytic4, da.acc_number, an.anl_number, da.acc_name,
                                a2.anl_number as sANL2,
                                a3.anl_number as sANL3,
                                a4.anl_number as sANL4

                from parus.yprepos01 d
                left join DicAccs da on da.rn = d.account
                left join DICANLS an on an.rn = d.analytic1
                left join DICANLS a2 on a2.rn = d.analytic2
                left join DICANLS a3 on a3.rn = d.analytic3
                left join DICANLS a4 on a4.rn = d.analytic4
                where d.authid = user
                order by da.acc_number, an.anl_number, a2.anl_number, a3.anl_number, a4.anl_number )
  loop
    nAccount := recA.Account;
    nAnalytic1 := nvl(recA.Analytic1,0);
    if recA.Anl_Number is null then
      sAccount := recA.Acc_Number; --|| ' ' || recA.Acc_Name;
    else
      sAccount := recA.anl_number || recA.Acc_Number; --|| ' ' || recA.Acc_Name;
    end if;
    if recA.Sanl2 is not null then
       sAccount := sAccount||' 2:'||recA.sANL2;
    end if;
    if recA.Sanl3 is not null then
       sAccount := sAccount||' 3:'||recA.sANL3;
    end if;
    if recA.Sanl4 is not null then
       sAccount := sAccount||' 4:'||recA.sANL4;
    end if;
    sAccount := sAccount ||' '||recA.Acc_Name;

    DrawAccount( sAccount );
    ResetVarA;
    nJurPers := 0;

    for recO in ( select distinct d.jur_pers, j.code, j.name
                  from parus.yprepos01 d
                  left join jurpersons j on j.rn = d.jur_pers
                  where d.authid = user and d.account = nAccount
                    and nvl(d.analytic1,0) = nAnalytic1
                    and nvl(d.analytic2,0) = nvl(recA.Analytic2,0)
                    and nvl(d.analytic3,0) = nvl(recA.Analytic3,0)
                    and nvl(d.analytic4,0) = nvl(recA.Analytic4,0)
                  order by j.Code )
    loop
      nJurPers := recO.Jur_Pers;
      sJurPers := recO.Code || ' ' || recO.name;
      DrawOrg( sJurPers );
      ResetVarO;
      nAgent := 0;
      for recM in ( select distinct d.Agent, a.AgnAbbr, a.Agnname
                    from parus.yprepos01 d
                    left join AgnList a on a.rn = d.agent
                    where d.authid = user and d.account = nAccount and nvl(d.analytic1,0) = nAnalytic1 and d.jur_pers = nJurPers
                      and nvl(d.analytic2,0) = nvl(recA.Analytic2,0)
                      and nvl(d.analytic3,0) = nvl(recA.Analytic3,0)
                      and nvl(d.analytic4,0) = nvl(recA.Analytic4,0)
                    order by a.AgnAbbr )
      loop
        nAgent := recM.Agent;
        sAgent := recM.AgnName;
        if nTotalsOnly = 0 then
          DrawMol( sAgent );
        end if;
        ResetVarM;

        appMode := appAfterMOL;
        for recD in ( select nm.nomen_name, i.object_model, min(d.datein) as datein, d.inum,
                             sum( nvl(d.acnt_remn_quant, 0) ) QBE, sum( nvl(d.acnt_remn_sum, 0) ) SBE,
                             sum( nvl(d.acnt_debit_turn_quant, 0) ) QDE, sum( nvl(d.acnt_debit_turn_sum, 0) ) SDE,
                             sum( nvl(d.acnt_credit_turn_quant, 0) ) QCR, sum( nvl(d.acnt_credit_turn_sum, 0) ) SCR,
                             sum( nvl(d.amortall, 0) ) AMORTA,
                             sum( nvl(d.amortperiod,0) ) AMORTP
                      from parus.yprepos01 d
                      left join DICNOMNS NM on nm.rn = d.nomenclature
                      left join inventory  I on i.rn = d.rn
                      where d.authid = user and d.account = nAccount and nvl(d.analytic1,0) = nAnalytic1 and
                            d.jur_pers = nJurPers and d.agent = nAgent
                        and nvl(d.analytic2,0) = nvl(recA.Analytic2,0)
                        and nvl(d.analytic3,0) = nvl(recA.Analytic3,0)
                        and nvl(d.analytic4,0) = nvl(recA.Analytic4,0)
                      group by nm.nomen_name, i.object_model, d.inum
                      order by d.inum )
        loop
          nQBE := recD.QBE; nSBE := recD.SBE; nQDE := recD.QDE; nSDE := recD.SDE; nQCR := recD.QCR; nSCR := recD.SCR;
          nQFIN := recD.QBE + recD.QDE - recD.QCR;
          nSFIN := recD.SBE + recD.SDE - recD.SCR;
          nOstSum := pkg_util.iif(nvl(nAMORTBGN,0)= 0, pkg_util.iif( nSFIN = 0, 0, nSFIN - recD.AMORTA ),pkg_util.iif( recD.SBE = 0, 0, recD.SBE - recD.AMORTA )) ;
          nAMORTP := recD.AMORTP;
          nAMORTA := recD.AMORTA;
          SumMOL;
          if nTotalsOnly = 0 then
            DrawData( trim(recD.nomen_name) || trim( pkg_util.iif(recD.object_model is null, '', ', '||recD.Object_model) ) , trim( recD.INum) );
          end if;
        end loop;
        SumOrg;
        DrawMolT( sAgent );

      end loop;
      SumAccount;
      DrawOrgT( sJurPers );

    end loop;
    SumTotals;
    DrawAccountT( sAccount );

  end loop;
  DrawTotal;

  DeleteRowsTemplates;

  if nCheckErrors = 1 then
    --   
    P_YPTURNIKERROR( nIDENT, nSELECT, nPRINTSELECT, nCHECKACC );

    --    
    prsg_excel.SHEET_SELECT( PAGE_ERRORS );

    InitERowsAndCellsTemplates;

    DrawHDRE( dDateF, dDateT );
    iNpp := 0;

    nAccount := 0; nAnalytic1 := 0;

    for recA in ( select distinct d.account, d.analytic1,d.analytic2,d.analytic3,d.analytic4, da.acc_number, an.anl_number, da.acc_name,
                       a2.anl_number as sANL2,
                       a3.anl_number as sANL3,
                       a4.anl_number as sANL4
                  from parus.yprepos02 d
                  left join DicAccs da on da.rn = d.account
                  left join DICANLS an on an.rn = d.analytic1
                  left join DICANLS a2 on a2.rn = d.analytic2
                  left join DICANLS a3 on a3.rn = d.analytic3
                  left join DICANLS a4 on a4.rn = d.analytic4
                  where d.authid = user
                  order by da.acc_number, an.anl_number )
    loop
      nAccount := recA.Account;
      nAnalytic1 := nvl(recA.Analytic1,0);
      if recA.Anl_Number is not null then
        sAccount := recA.anl_number || recA.Acc_Number;
      else
        sAccount := recA.Acc_Number;
      end if;
      if recA.Sanl2 is not null then
         sAccount := sAccount||' 2:'||recA.sANL2;
      end if;
      if recA.Sanl3 is not null then
         sAccount := sAccount||' 3:'||recA.sANL3;
      end if;
      if recA.Sanl4 is not null then
         sAccount := sAccount||' 4:'||recA.sANL4;
      end if;
      DrawAccountE( sAccount );
      nJurPers := 0;

      for recO in ( select distinct d.jurpers, j.code, j.name
                    from parus.yprepos02 d
                    left join jurpersons j on j.rn = d.jurpers
                    where d.authid = user and d.account = nAccount
                      and nvl(d.analytic1,0) = nAnalytic1
                      and nvl(d.analytic2,0) = nvl(recA.Analytic2,0)
                      and nvl(d.analytic3,0) = nvl(recA.Analytic3,0)
                      and nvl(d.analytic4,0) = nvl(recA.Analytic4,0)
                    order by j.Code )
      loop
        nJurPers := recO.JurPers;
        sJurPers := recO.Code || ' ' || recO.name;
        DrawOrgE( sJurPers );
        nAgent := 0;
        for recM in ( select distinct d.Agent, a.AgnAbbr, a.Agnname
                      from parus.yprepos02 d
                      left join AgnList a on a.rn = d.agent
                      where d.authid = user
                        and d.account = nAccount
                        and nvl(d.analytic1,0) = nAnalytic1
                        and d.jurpers = nJurPers
                        and nvl(d.analytic2,0) = nvl(recA.Analytic2,0)
                        and nvl(d.analytic3,0) = nvl(recA.Analytic3,0)
                        and nvl(d.analytic4,0) = nvl(recA.Analytic4,0)
                      order by a.AgnAbbr )
        loop
          nAgent := recM.Agent;
          sAgent := recM.AgnName;
          DrawMolE( sAgent );

          appMode := appAfterMOL;
          for recD in ( select nm.nomen_code, d.Note,
                               sum( nvl(d.QMAT, 0) ) QMAT, sum( nvl(d.SMAT, 0) ) SMAT,
                               sum( nvl(d.QOS, 0) ) QOS, sum( nvl(d.SOS, 0) ) SOS
                        from parus.yprepos02 d
                        left join DICNOMNS NM on nm.rn = d.nomenclator
                        where d.authid = user and d.account = nAccount and nvl(d.analytic1,0) = nAnalytic1 and
                              d.jurpers = nJurPers and nvl(d.agent,0) = nvl(nAgent,0)
                          and nvl(d.analytic2,0) = nvl(recA.Analytic2,0)
                          and nvl(d.analytic3,0) = nvl(recA.Analytic3,0)
                          and nvl(d.analytic4,0) = nvl(recA.Analytic4,0)
                        group by nm.nomen_code, d.Note
                         )
          loop
            nQMAT := recD.QMAT; nSMAT := recD.SMAT; nQOS := recD.QOS; nSOS := recD.SOS;
            nQSUB := recD.QMAT - recD.QOS;
            nSSUB := recD.SMAT - recD.SOS;
            DrawDataE( trim(nvl(recD.nomen_code,'')), trim( recD.Note) );
          end loop;

        end loop;

      end loop;

    end loop;

    DeleteERowsTemplates;
  else
    prsg_excel.SHEET_DELETE( PAGE_ERRORS );
  end if;

  prsg_excel.SHEET_SELECT( PAGE_REPORT );

end;

/
grant execute on P_YPTURNIKCREATE_EXCEL to public;