create or replace view v_inventory
(nrn, ncompany, ncrn, scrn, njur_pers, sjur_pers, nobj_status, saccount, sbalunit, scurrency, sexec, nexec_crn, sobj_group, sobj_number, sinv_number, scard_pref, scard_numb, scard_pref_trim, scard_numb_trim, nnomenclature, snom, snom_name, nnom_crn, scl_pref, scl_numb, nokof, sokof, sokof_name, nokof_94, sokof_94, sokof_94_name, sobj_note, sobj_model, sobj_place, sobj_place_name, swors_number, sreg_number, sother_number, sobjfunc, nproducer, sproducer, na_b_cost, nab_b_cost, nc_b_cost, ncb_b_cost, na_sum_fund, nab_sum_fund, nc_sum_fund, ncb_sum_fund, na_b_amort, nab_b_amort, nc_b_amort, ncb_b_amort, dam_dur_date, na_d_amort, nab_d_amort, nc_d_amort, ncb_d_amort, na_e_cost, nab_e_cost, nc_e_cost, ncb_e_cost, sam_code, namort_year, namort_year_c, nam_fast, ncam_fast, sanalytic1, sanalytic2, sanalytic3, sanalytic4, sanalytic5, ncard_type, drelease_date, dincome_date, nitem_count, nsubdiv, ssubdiv, namort_run, namort_run_c, nacnt_run, nctrl_run, namort_type, nacnt_term_use, nctrl_term_use, nacnt_term_use_rest, nctrl_term_use_rest, ntax_group, stax_group, namort_quota, ntax_subgroup, stax_subgroup, na_amort_percent, nc_amort_percent, nab_amort_percent, ncb_amort_percent, nuse_cost_end, namort_from_begin, nacctypes, sacctypes, nacctypes_type, ninvobject, sinvobject, ninvobjcl, sinvobjcl, sinvobjcl_name, noper_rule, soper_rule, namort_rn, nstate_regist, nassets_limit, staxobjtypes, ntaxobjtypes, namort_sum_cap, na_sum_cap, nab_sum_cap, nc_sum_cap, ncb_sum_cap, na_amort_off, nab_amort_off, nc_amort_off, ncb_amort_off, nbalelement, sbalelement, ninv_numb_sign, sbarcode, dlabel_date, nfree_sign, ntermus_prbal, ncost_place, scost_place, din_date, dout_date)
as
select
  M.RN,                                 -- nRN
  M.COMPANY,                            -- nCOMPANY
  M.CRN,                                -- nCRN
  (select CC.NAME from ACATALOG CC where CC.RN = M.CRN), -- sCRN
  M.JUR_PERS,                           -- nJUR_PERS
  (select JP.CODE from JURPERSONS JP where JP.RN = M.JUR_PERS), -- sJUR_PERS
  M.OBJ_STATUS,                         -- nOBJ_STATUS
  (select A.ACC_NUMBER from DICACCS A where A.RN = M.ACCOUNT), -- sACCOUNT
  (select B.BUNIT_MNEMO from DICBUNTS B where B.RN = M.BALUNIT), -- sBALUNIT
  (select C1.INTCODE from CURNAMES C1 where C1.RN = M.CURRENCY), -- sCURRENCY
  (select AG.AGNABBR from AGNLIST AG where AG.RN = M.EXECUTIVE), -- sEXEC
  (select AG.CRN from AGNLIST AG where AG.RN = M.EXECUTIVE), -- nEXEC_CRN
  M.OBJECT_GROUP,                       -- sOBJ_GROUP
  M.OBJECT_NUMBER,                      -- sOBJ_NUMBER
  M.INV_NUMBER,                         -- sINV_NUMBER
  M.CARD_PREF,                          -- sCARD_PREF
  M.CARD_NUMB,                          -- sCARD_NUMB
  ltrim(M.CARD_PREF),                   -- sCARD_PREF_TRIM
  ltrim(M.CARD_NUMB),                   -- sCARD_NUMB_TRIM
  M.NOMENCLATURE,                       -- nNOMENCLATURE
  (select N.NOMEN_CODE from DICNOMNS N where N.RN = M.NOMENCLATURE), -- sNOM
  (select N.NOMEN_NAME from DICNOMNS N where N.RN = M.NOMENCLATURE), -- sNOM_NAME
  (select N.CRN from DICNOMNS N where N.RN = M.NOMENCLATURE), -- nNOM_CRN
  M.CLASS_PREF,                         -- sCL_PREF
  M.CLASS_NUMB,                         -- sCL_NUMB
  M.OKOF,                               -- nOKOF
  (select O.CODE from OKOF O where O.RN = M.OKOF), -- sOKOF
  (select O.NAME from OKOF O where O.RN = M.OKOF), -- sOKOF_NAME
  M.OKOF_94,                            -- nOKOF_94
  (select O.CODE from OKOF O where O.RN = M.OKOF_94), -- sOKOF_94
  (select O.NAME from OKOF O where O.RN = M.OKOF_94), -- sOKOF_94_NAME
  M.OBJECT_NOTE,                        -- sOBJ_NOTE
  M.OBJECT_MODEL,                       -- sOBJ_MODEL
  (select P.PLACE_MNEMO from DICPLACE P where P.RN = M.OBJECT_PLACE), -- sOBJ_PLACE
  (select P.PLACE_NAME from DICPLACE P where P.RN = M.OBJECT_PLACE), -- sOBJ_PLACE_NAME
  M.WORS_NUMBER,                        -- sWORS_NUMBER
  M.REG_NUMBER,                         -- sREG_NUMBER
  M.OTHER_NUMBER,                       -- sOTHER_NUMBER
  M.OBJFUNC,                            -- sOBJFUNC
  M.PRODUCER,                           -- nPRODUCER
  (select PR.AGNABBR from AGNLIST PR where PR.RN = M.PRODUCER), -- sPRODUCER
  M.A_COST_BEGIN,                       -- nA_B_COST
  M.AB_COST_BEGIN,                      -- nAB_B_COST
  M.C_COST_BEGIN,                       -- nC_B_COST
  M.CB_COST_BEGIN,                      -- nCB_B_COST
  M.A_SUM_FUND,                         -- nA_SUM_FUND
  M.AB_SUM_FUND,                        -- nAB_SUM_FUND
  M.C_SUM_FUND,                         -- nC_SUM_FUND
  M.CB_SUM_FUND,                        -- nCB_SUM_FUND
  M.A_AMORT_BEGIN,                      -- nA_B_AMORT
  M.AB_AMORT_BEGIN,                     -- nAB_B_AMORT
  M.C_AMORT_BEGIN,                      -- nC_B_AMORT
  M.CB_AMORT_BEGIN,                     -- nCB_B_AMORT
  M.AMORT_DURING_DATE,                  -- dAM_DUR_DATE
  M.A_AMORT_DURING,                     -- nA_D_AMORT
  M.AB_AMORT_DURING,                    -- nAB_D_AMORT
  M.C_AMORT_DURING,                     -- nC_D_AMORT
  M.CB_AMORT_DURING,                    -- nCB_D_AMORT
  M.A_COST_END,                         -- nA_E_COST
  M.AB_COST_END,                        -- nAB_E_COST
  M.C_COST_END,                         -- nC_E_COST
  M.CB_COST_END,                        -- nCB_E_COST
  (select AM.AMORT_CODE from DICAMORT AM where AM.RN = M.AMORT_RN), -- sAM_CODE
  (select AM.AMORT_YEAR from DICAMORT AM where AM.RN = M.AMORT_RN), -- nAMORT_YEAR
  (select AM.AMORT_YEAR_C from DICAMORT AM where AM.RN = M.AMORT_RN), -- nAMORT_YEAR_C
  M.AMORT_FAST,                         -- nAM_FAST
  M.CAMORT_FAST,                        -- nCAM_FAST
  (select A1.ANL_NUMBER from DICANLS A1 where A1.RN = M.ANALYTIC1), -- sANALYTIC1
  (select A2.ANL_NUMBER from DICANLS A2 where A2.RN = M.ANALYTIC2), -- sANALYTIC2
  (select A3.ANL_NUMBER from DICANLS A3 where A3.RN = M.ANALYTIC3), -- sANALYTIC3
  (select A4.ANL_NUMBER from DICANLS A4 where A4.RN = M.ANALYTIC4), -- sANALYTIC4
  (select A5.ANL_NUMBER from DICANLS A5 where A5.RN = M.ANALYTIC5), -- sANALYTIC5
  M.CARD_TYPE,                          -- nCARD_TYPE
  M.RELEASE_DATE,                       -- dRELEASE_DATE
  M.INCOME_DATE,                        -- dINCOME_DATE
  M.ITEM_COUNT,                         -- nITEM_COUNT
  M.SUBDIV,                             -- nSUBDIV
  (select DEP.CODE from INS_DEPARTMENT DEP where DEP.RN = M.SUBDIV), -- sSUBDIV
  (select AM.AMORT_RUN from DICAMORT AM where AM.RN = M.AMORT_RN), -- nAMORT_RUN
  (select AM.AMORT_RUN_C from DICAMORT AM where AM.RN = M.AMORT_RN), -- nAMORT_RUN_C
  M.ACNT_RUN,                           -- nACNT_RUN
  M.CTRL_RUN,                           -- nCTRL_RUN
  M.AMORT_TYPE,                         -- nAMORT_TYPE
  M.ACNT_TERM_USE,                      -- nACNT_TERM_USE
  M.CTRL_TERM_USE,                      -- nCTRL_TERM_USE
  M.A_TERM_USE_REST,                    -- nACNT_TERM_USE_REST
  M.C_TERM_USE_REST,                    -- nCTRL_TERM_USE_REST
  M.TAX_GROUP,                          -- nTAX_GROUP
  (select ITG.CODE from INVTAXGR ITG where ITG.NUMB = M.TAX_GROUP), -- sTAX_GROUP
  (select ITG.AMORT_QUOTA from INVTAXGR ITG where ITG.NUMB = M.TAX_GROUP), -- nAMORT_QUOTA
  M.TAX_SUBGROUP,                       -- nTAX_SUBGROUP
  (select ITSG.CODE from INVTAXSUBGR ITSG where ITSG.RN = M.TAX_SUBGROUP), -- sTAX_SUBGROUP
  case M.A_COST_BEGIN
    when 0 then
      0
    else
      round((1-(M.A_COST_END+nvl(GET_OPTIONS_NUM('InventoryFundUse',M.COMPANY),0)*M.A_SUM_FUND)/M.A_COST_BEGIN)*100,2)
  end,                                  -- nA_AMORT_PERCENT
  case M.C_COST_BEGIN
    when 0 then
      0
    else
      round((1-(M.C_COST_END+nvl(GET_OPTIONS_NUM('InventoryFundUse',M.COMPANY),0)*M.C_SUM_FUND)/M.C_COST_BEGIN)*100,2)
  end,                                  -- nC_AMORT_PERCENT
  case M.AB_COST_BEGIN
    when 0 then
      0
    else
      round((1-(M.AB_COST_END+nvl(GET_OPTIONS_NUM('InventoryFundUse',M.COMPANY),0)*M.AB_SUM_FUND)/M.AB_COST_BEGIN)*100,2)
  end,                                  -- nAB_AMORT_PERCENT
  case M.CB_COST_BEGIN
    when 0 then
      0
    else
      round((1-(M.CB_COST_END+nvl(GET_OPTIONS_NUM('InventoryFundUse',M.COMPANY),0)*M.CB_SUM_FUND)/M.CB_COST_BEGIN)*100,2)
  end,                                  -- nCB_AMORT_PERCENT
  M.USE_COST_END,                       -- nUSE_COST_END
  M.AMORT_FROM_BEGIN,                   -- nAMORT_FROM_BEGIN
  M.ACCTYPES,                           -- nACCTYPES
  (select ACT.CODE from ACCTYPES ACT where ACT.RN = M.ACCTYPES), -- sACCTYPES
  (select ACT.TYPE from ACCTYPES ACT where ACT.RN = M.ACCTYPES), -- nACCTYPES_TYPE
  M.INVOBJECT,                          -- nINVOBJECT
  (select INO.CODE from INVOBJECTS INO where INO.RN = M.INVOBJECT), -- sINVOBJECT
  M.INVOBJCL,                           -- nINVOBJCL
  (select IOCL.CODE from INVOBJECTCL IOCL where IOCL.RN = M.INVOBJCL), -- sINVOBJCL
  M.INVOBJCL_NAME,                      -- sINVOBJCL_NAME
  M.OPER_RULE,                          -- nOPER_RULE
  (select IOM.CODE from INVOPERMODEL IOM where IOM.RN = M.OPER_RULE), -- sOPER_RULE
  M.AMORT_RN,                           -- nAMORT_RN
  M.STATE_REGIST,                       -- nSTATE_REGIST
  M.ASSETS_LIMIT,                       -- nASSETS_LIMIT
  (select TAX.CODE from TAXOBJTYPES TAX where TAX.RN = M.TAXOBJTYPES), -- sTAXOBJTYPES
  M.TAXOBJTYPES,                        -- nTAXOBJTYPES
  M.AMORT_SUM_CAP,                      -- nAMORT_SUM_CAP
  M.A_SUM_CAP,                          -- nA_SUM_CAP
  M.AB_SUM_CAP,                         -- nAB_SUM_CAP
  M.C_SUM_CAP,                          -- nC_SUM_CAP
  M.CB_SUM_CAP,                         -- nCB_SUM_CAP
  M.A_AMORT_OFF,                        -- nA_AMORT_OFF
  M.AB_AMORT_OFF,                       -- nAB_AMORT_OFF
  M.C_AMORT_OFF,                        -- nC_AMORT_OFF
  M.CB_AMORT_OFF,                       -- nCB_AMORT_OFF
  (select A.BALUNIT from DICACCS A where A.RN = M.ACCOUNT), -- nBALELEMENT
  (select BE.CODE from BALELEMENT BE where BE.RN = (select A.BALUNIT from DICACCS A where A.RN = M.ACCOUNT)), -- sBALELEMENT
  M.INV_NUMB_SIGN,                      -- nINV_NUMB_SIGN
  M.BARCODE,                            -- sBARCODE
  M.LABEL_DATE,                         -- dLABEL_DATE
  M.FREE_SIGN,                          -- nFREE_SIGN
  M.TERMUS_PRBAL,                       -- nTERMUS_PRBAL
  M.COST_PLACE,                         -- nCOST_PLACE
  (select CP.CODE from FPDACCNT CP where CP.RN = M.COST_PLACE), -- sCOST_PLACE,
  (select H.Action_Date from  INVHIST H where H.PRN=M.RN and H.Action_Type=0),  -- egor 04/09/08   /*parusyp*/
  (select H.Action_Date from  INVHIST H where H.PRN=M.RN and H.Action_Type=4)   -- egor 04/09/08 
from
  INVENTORY M
where
      exists
      (
        select /*+ INDEX(UP I_USERPRIV_CATALOG_ROLEID) */ null
          from USERPRIV UP
          where     UP.CATALOG = M.CRN
                and UP.ROLEID in(select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */ UR.ROLEID from USERROLES UR where UR.AUTHID = UTILIZER)
        union all
        select /*+ INDEX(UP I_USERPRIV_CATALOG_AUTHID) */ null
          from USERPRIV UP
          where     UP.CATALOG = M.CRN
                and UP.AUTHID  = UTILIZER
      )
  and exists
      (
        select /*+ INDEX(UP I_USERPRIV_JUR_PERS_ROLEID) */ null
          from USERPRIV UP
          where     UP.JUR_PERS = M.JUR_PERS
                and UP.UNITCODE = 'Inventory'
                and UP.ROLEID in(select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */ UR.ROLEID from USERROLES UR where UR.AUTHID = UTILIZER)
        union all
        select /*+ INDEX(UP I_USERPRIV_JUR_PERS_AUTHID) */ null
          from USERPRIV UP
          where     UP.JUR_PERS = M.JUR_PERS
                and UP.UNITCODE = 'Inventory'
                and UP.AUTHID   = UTILIZER
      );
